//======================================================================================================
// ID.H
// Copyright 2022 Everett Kaser
// All rights reserved
//======================================================================================================

// we intentionally don't use ID "0"

#define	ID_MAIN				1		// The .KE program's MAIN window
#define	ID_MENU_BUTT		2		// The main MENU button
#define	ID_MENU_BUTT_CLOSE	3		// the 'duplicate' MENU button that OK's the modal dialog
#define	ID_MENU_DLG			4
#define	ID_MENU_GROUP		5

#define	ID_OK				10
#define	ID_CANCEL			11
#define	ID_YES				12
#define	ID_NO				13
#define	ID_RESET			14
#define	ID_CLOSE			15
#define	ID_EXIT				16


// NOTE: since there may be many scrollbars in existance at once,
// and they all use these same IDs for their scrollbar buttons,
// NO calls to SendMsgID or FindWndID, etc, can be made using these
// IDs.  You MUST access these buttons via their PARENT window.
#define	ID__SCROLLV	20	// generic ID for vertical scrollbar
#define	ID__SCROLLH	21	// generic ID for horizontal scrollbar
#define	ID__BOXBUTT 22	// generic ID for Scrollbar scrollbox button
#define	ID__MINBUTT	23	// generic ID's for use by Scrollbars for their
#define	ID__MAXBUTT	24	// up/dn or lf/rt pushbuttons

#define	ID_NOTIFY_DLG		30
#define	ID_NOTIFY_MSG		31

#define	ID_MENU_HELP		50
#define	ID_MENU_BESTMOVES	51
#define	ID_MENU_ABOUT		52

#define	ID_MENU_PLYR_SEL	55
#define	ID_MENU_PLYR_ADD	56
#define	ID_MENU_PLYR_REN	57
#define	ID_MENU_PLYR_DEL	58

#define	ID_MENU_MOOD_SEL	61
#define	ID_MENU_MOOD_ADD	62
#define	ID_MENU_MOOD_REN	63
#define	ID_MENU_MOOD_DEL	64
#define	ID_MENU_CURMOOD		65

#define	ID_MENU_GRAPHICS	70
#define	ID_MENU_INTERFACE	71
#define	ID_MENU_LANG		72

#define	ID_MENU_MUSIC		75
#define	ID_MENU_MOUSE		76
#define	ID_MENU_KEYS		77

#define ID_MENU_OPTIONS		80

#define	ID_MENU_EXIT		85

#define	ID_MENU_SPACE1		91
#define	ID_MENU_SPACE2		92
#define	ID_MENU_SPACE3		93
#define	ID_MENU_SPACE4		94
#define	ID_MENU_SPACE5		95
#define	ID_MENU_SPACE6		96

#define	ID_ABOUT_SPLASH		100
#define	ID_ABOUT_GROUP1		101

#define	ID_ABOUT_COPYRIGHT0	102
#define	ID_ABOUT_COPYRIGHT1	103
#define	ID_ABOUT_COPYRIGHT2	104
#define	ID_ABOUT_COPYRIGHT3	105
#define	ID_ABOUT_COPYRIGHT4	106
#define	ID_ABOUT_GROUP2		107
#define	ID_ABOUT_CONTACT1	108
#define	ID_ABOUT_CONTACT2	109
#define	ID_ABOUT_CONTACT3	110
#define	ID_ABOUT_CONTACT4	111
#define	ID_ABOUT_CONTACT5	112
#define	ID_ABOUT_CONTACT6	113
#define	ID_ABOUT_GROUP3		114
#define	ID_ABOUT_BUILD1		115
#define	ID_ABOUT_BUILD2		116
#define	ID_ABOUT_SCREEN		117
#define	ID_ABOUT_WINDOW		118
#define	ID_ABOUT_UI			119
#define	ID_ABOUT_COPY		120
#define	ID_ABOUT_KINT		121

#define	ID_MSG_BOX			200		// only ONE MessageBox() can be active at a time!
#define	ID_MSG_BOX_CTL		201		// takes up 49 ID slots for MessageBox text/button controls




#define	IDNEXTAVAIL			250


#define	ID_LIST				1000


#define	ID_OPT_GROUP1		1001
#define	ID_OPT_GROUP2		1002

#define	ID_BYPASS_TITLE		1006
#define	ID_GAMESOUNDS		1007
#define	ID_ERRORSOUNDS		1008
#define	ID_SHOWSAVESTART	1009
#define	ID_SHOWSAVESIZE		1010
#define	ID_AUTODELSAVES		1011
#define	ID_PROMPTNEXT		1012
#define	ID_PROMPTRESTART	1013
#define	ID_ENABLECLICK		1014
#define	ID_STARTBOTTOM		1015
#define	ID_SCRAMBLEORDER	1016
#define	ID_SHOWTIMER		1017
#define	ID_SHOWTILESMOVED	1018
#define	ID_SHOWBESTCOUNT	1019
#define	ID_SHOW_TOOLTIPS	1020
#define	ID_REMOVE_PAUSE		1021

#define	ID_WINGROUP			1050
#define	ID_WIN_FIRE			1051
#define	ID_WIN_QUILT		1052
#define	ID_WIN_WEAVE		1053
#define	ID_WIN_BOUNCE		1054
#define	ID_WIN_RANDOM		1055
#define	ID_WIN_NONE			1056
#define	ID_WIN_DELAY		1057
#define	ID_WIN_SPEED		1058

#define	ID_PUZZLE_SIZE		1060
#define	ID_CSV_SEP			1061

#define	ID_NEWPLYGROUP	1100
#define	ID_NEWPLYNAME	1101
#define	ID_NPMOODGROUP	1102
#define	ID_DEFMOOD		1103
#define	ID_COPYCURMOOD	1104
#define	ID_COPYALLMOODS	1105
#define	ID_NPDEFMOODNAME	1106
#define	ID_NEWPLYADD	1107

#define	ID_RENPLYGROUP	1120
#define	ID_RENPLYNAME	1121
#define	ID_RENPLYREN	1122

#define	ID_IF_IMGBY		1130
#define	ID_IF_CREDITS	1131
#define	ID_IF_UUGROUP	1132
#define	ID_IF_UUSIZE	1133
#define	ID_IF_UULABEL	1134
#define	ID_IF_SIZE		1135

#define	ID_IF_SIZEBUTT0	1140
#define	ID_IF_SIZEBUTT1	1141
#define	ID_IF_SIZEBUTT2	1142
#define	ID_IF_SIZEBUTT3	1143
#define	ID_IF_SIZEBUTT4	1144
#define	ID_IF_SIZEBUTT5	1145
#define	ID_IF_SIZEBUTT6	1146
#define	ID_IF_SIZEBUTT7	1147
#define	ID_IF_SIZEBUTT8	1148
#define	ID_IF_SIZEBUTT9	1149
// etc, etc.


#define	ID_SELPLAYER	1200

#define	ID_TEST1		1300
#define	ID_TEST2		1301
#define	ID_TEST3		1302
#define	ID_TESTGROUP	1303

#define	ID_SELMOOD		1310
#define	ID_SELECTMOOD	1311

#define	ID_NEWMOODGROUP	1320
#define	ID_NEWMOODNAME	1321
#define	ID_NEWMOODCOPY	1322
#define	ID_NEWMOODADD	1323

#define	ID_RENMOODGROUP	1330
#define	ID_RENMOODNAME	1331
#define	ID_RENMOODREN	1332

#define	ID_GG_GROUP		1340
#define	ID_GG_IMGBY		1341
#define	ID_GG_CREDITS	1342
#define	ID_GG_PREVIEW	1343

#define	ID_MUSIC_DLG	1350
#define	ID_ADDWIN		1351
#define	ID_ADDWINALL	1352
#define	ID_REMWIN		1353
#define	ID_REMWINALL	1354
#define	ID_RANDMUSIC	1355
#define	ID_PLAYBACK		1356
#define	ID_LISTBACK		1357
#define	ID_PLAYWIN		1358
#define	ID_LISTWIN		1359
#define	ID_MUSIC_GROUP	1360
#define	ID_ADDBACK		1361
#define	ID_ADDBACKALL	1362
#define	ID_REMBACK		1363
#define	ID_REMBACKALL	1364
#define	ID_TEST			1365

#define	ID_MM_BUTTGROUP	1370
#define	ID_MM_ACTGROUP	1371
#define	ID_MM_LEFT		1372
#define	ID_MM_MIDDLE	1373
#define	ID_MM_RIGHT		1374
#define	ID_MM_BACK		1375
#define	ID_MM_FWD		1376
#define	ID_MM_SLEFT		1377
#define	ID_MM_SMIDDLE	1378
#define	ID_MM_SRIGHT	1379
#define	ID_MM_SBACK		1380
#define	ID_MM_SFWD		1381
#define	ID_MM_CLEFT		1382
#define	ID_MM_CMIDDLE	1383
#define	ID_MM_CRIGHT	1384
#define	ID_MM_CBACK		1385
#define	ID_MM_CFWD		1386
#define	ID_MM_SCLEFT	1387
#define	ID_MM_SCMIDDLE	1388
#define	ID_MM_SCRIGHT	1389
#define	ID_MM_SCBACK	1390
#define	ID_MM_SCFWD		1391

#define	ID_REV_WHEEL	1392
#define	ID_REV_TILT		1393
#define	ID_MIRROR_CHANGES	1394
#define	ID_MM_EXPORT	1395

#define	ID_MM_FIRSTACT	1400
#define	ID_MM_NOACTION	1400
#define	ID_MM_MOVETILE	1401
#define	ID_MM_FINDAVAIL	1402
#define	ID_MM_FINDTPBT	1403
#define	ID_MM_FINDALL	1404
#define	ID_MM_UNDO		1405
#define	ID_MM_REDO		1406
#define	ID_MM_NEXT_MOOD	1407
#define	ID_MM_PREV_MOOD	1408
#define	ID_MM_LASTACT	1408

#define	ID_HELP_GROUP	1420
#define	ID_HELP_TITLE	1421
#define	ID_HELP_TEXT	1422
#define	ID_HELP_CHANGED	1423
#define	ID_HELP_HIDE	1424
#define	ID_HELP_EXPORT	1425
#define	ID_HELP_INDEX	1426
#define	ID_HELP_BACK	1427
#define	ID_HELP_PREV	1428
#define	ID_HELP_NEXT	1429

#define	ID_LANG_GROUP	1440
#define	ID_LANG_STRINGS	1441
#define	ID_LANG_HELP	1442
#define	ID_LANG_STR_BY	1443
#define	ID_LANG_HLP_BY	1444

#define	ID_KEYMAP_LIST	1450
#define	ID_KEYS_LIST	1451
#define	ID_KEY_SHIFT	1452
#define	ID_KEY_CTL		1453
#define	ID_FUNC_LIST	1454
#define	ID_KEY_ADD		1455
#define	ID_KEY_DELETE	1456
#define	ID_KEY_MOVE		1457
#define	ID_KEY_DUPE		1458
#define	ID_KEY_RESET	1459
#define	ID_KEY_EXPORT	1460
#define	ID_KEY_HELP		1461
#define	ID_KEY_GROUP	1462

#define	ID_KEYCODE_DLG	1470
#define	ID_KEYVAL		1471
#define	ID_MD_KEYS_LIST	1472
#define	ID_MD_FUNC_LIST	1473
#define	ID_KEYMOVEDUPE_DLG	1474

#define	ID_MSG_BAR_DLG	1900

#define	ID_BUTT_BAR_DLG	2000
#define	ID_PUZZH_2	2001
#define	ID_PUZZH_3	2002
#define	ID_PUZZH_4	2003
#define	ID_PUZZH_5	2004
#define	ID_PUZZH_6	2005
#define	ID_PUZZH_7	2006
#define	ID_PUZZW_2	2007
#define	ID_PUZZW_3	2008
#define	ID_PUZZW_4	2009
#define	ID_PUZZW_5	2010

#define	ID_PREVPUZZ		2020
#define	ID_NEXTPUZZ		2021
#define	ID_PUZZNUM		2022
#define	ID_RESTART		2023
#define	ID_SAVEGAME		2024
#define	ID_UNDO			2025
#define	ID_REDO			2026
#define	ID_PAUSE		2027

#define	ID_TIME			2050
#define	ID_MOVES		2051
#define	ID_BEST			2052

#define	ID_DRAG_WND		2100

#define	ID_TITLE_DLG	2110
#define	ID_CONTINUE		2111
#define	ID_MODWARN1		2112
#define	ID_MODWARN2		2113
#define	ID_MODWARN3		2114
#define	ID_MODWARN4		2115
#define	ID_DEMO0		2116
#define	ID_DEMO1		2117
#define	ID_DEMO2		2118
#define	ID_DEMO3		2119
#define	ID_DEMO4		2120
#define	ID_DEMO5		2121

#define	ID_HUESCR			2135
#define	ID_SATSCR			2136
#define	ID_LITSCR			2137
#define	ID_HUEVAL			2138
#define	ID_SATVAL			2139
#define	ID_LITVAL			2140
#define	ID_HSL				2141
#define	ID_COLOR_PICKER		2142
#define	ID_RGB_VAL			2143
#define	ID_CP_COPY			2144
#define	ID_CP_PASTE			2145
#define	ID_CP_CLIP			2146

#define	ID_CP_R				2150
#define	ID_CP_G				2151
#define	ID_CP_B				2152

#define	ID_CP_DEC			2155
#define	ID_CP_HEX			2156


#define	ID_EXPORT_DLG		2200
#define	ID_EXPCLR_GROUP		2201
#define	ID_EXPCLR_BACK		2202
#define	ID_EXPCLR_TEXT		2203
#define	ID_EXPCLR_H1		2204
#define	ID_EXPCLR_H2		2205
#define	ID_EXPCLR_H3		2206
#define	ID_EXPCLR_CONTBACK	2207
#define	ID_EXPCLR_CONTTEXT	2208
#define	ID_EXPCLR_CONTLINK	2209
#define	ID_EXPCLR_HEADBACK	2210
#define	ID_EXPCLR_HEADTEXT	2211
#define	ID_EXPCLR_HEADFRAME	2212

#define	ID_EXFONTL_GROUP	2220
#define	ID_EXFONT_SANS		2221
#define	ID_EXFONT_SERIF		2222
#define	ID_EXFONT_DEF		2223
#define	ID_EXFONT_ARIAL		2224
#define	ID_EXFONT_VERDANA	2225
#define	ID_EXFONT_HELVETICA	2226
#define	ID_EXFONT_TAHOMA	2227
#define	ID_EXFONT_TIMES		2228
#define	ID_EXFONT_GEORGIA	2229
#define	ID_EXFONT_GARAMOND	2230
#define	ID_EXFONT_COUNT		(ID_EXFONT_GARAMOND-ID_EXFONT_DEF)

#define	ID_EXPOPT_GROUP		2234
#define	ID_HRULE			2235
#define	ID_LINKCONTENTS		2236
#define	ID_EXPWIDTH			2237
#define	ID_HRULE2			2238
#define	ID_EXPLMARGIN		2239
#define	ID_EXPCONTENTW		2240
#define	ID_EXPCONTENTSP		2241
#define	ID_HRULETOP			2242
#define	ID_HRULEBOT			2243
#define	ID_HRULE2TOP		2244
#define	ID_HRULE2BOT		2245

#define	ID_EXFONT_GROUP		2250
#define	ID_EXFONT_TEXT		2251
#define	ID_EXFONT_H1		2252
#define	ID_EXFONT_H2		2253
#define	ID_EXFONT_H3		2254

#define	ID_EXPHELP			2290
#define	ID_EXPSAVECHANGES	2291
#define	ID_EXPEXP1			2292
#define	ID_EXPEXP2			2293

#define	ID_EXP_ALLCNTS		2300
#define	ID_EXP_CURBEST		2301
#define	ID_IMP_CURBEST		2302
#define	ID_MERGE_ALL		2303
#define	ID_MERGE_CNT		2304
#define	ID_BEST_CNT			2305
