//======================================================================================================
// MAIN.H
// Copyright 2022 Everett Kaser
// All rights reserved
//======================================================================================================

#define	TRACKMM		0			// for tracking/debugging mouse messages

#define	INIREV		1			// revision# of .ini file
#define	UISIZED_REV	0xFF000004	// revision# (color of pixel (0,1)) of UIS* sized UI image files
#define	GSIZED_REV	0xFF000002	// revision# (color of pixel (0,1)) of GS* sized Game image files

#define	SIZEDTYPE		0	// 0 for BMP (fastest, most responsive), 1 for PNG (smallest file sizes)

#define	MENU_XOFF		0
#define	UIIMG_UW		56
#define	UIIMG_UH		84

void SetMsgText(char *str, DWORD backclr, DWORD textclr);
void StartPlayer(BOOL fullstart);
void OnBeginStartup();
void OnEndStartup();
void BeepIll();
void BeepMistake();
void OnChar(BYTE *pCharBuf, DWORD repflags);
void OnKeyUp(DWORD arg1, DWORD arg2, DWORD arg3);
void OnKeyDown(DWORD arg1, DWORD arg2, DWORD arg3);
void MouseMsg(DWORD msg, long x, long y, DWORD flags);
void SetupUUvars();
void mainDrawAll();
void SetMood(long dMood, long sMood);
void LoadUI(char *UIname);
void UpdateTitleBar();
void DefaultCurPlayer();
void DefaultCurMood();
void iniSavePlayer();
void iniSaveMood(long m);
void iniSaveHeader();
void UpdateMood();
BOOL iniLoadPlayer(long id);
void SizeUI();
void Notify(char *str, DWORD ExpireTime, DWORD bclr, DWORD tclr);
void EndPlayer();
void Encode(char *d);
void Decode(char *s);
void CheckBests();

DWORD MsgBarDlgProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3);
DWORD ButtBarDlgProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3);
DWORD BarButtBMProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3);

extern HWND		hMain, hMenuButt;
extern DWORD	hMainBM;
extern char		ScratBuf[8192];
extern DWORD	hUIBMO;		// handle of ORIGINAL UI graphics
extern long	UIBMUO;		// unit size of hUIBMO UI elements
extern DWORD	hUIBM;		// handle of game graphics
extern long		UIBMU;		// unit size of hUIBM UI elements, 1/4 of standard button w/h
extern long		UIBMU2;
extern long		UIBMU3;
extern long		UIBMU4;		// 4*UIBMU, size of standard button in hUIBM
extern long		UIBMU8;		// 8*UIBMU, width of CF_DBLWIDE button in hUIBM
extern DWORD	KeyFlags;						// SHIFT/CTL/MOUSE BUTTONS down
extern DWORD	MMlastX, MMlastY, MMlastFlags;	// for BACK (ALT-LFcurs) and FWD (ALT-RTcurs) emulation
extern HWND		hHover;			// WND over which the mouse is currently located
extern DWORD	hMainBM;
extern long		ViewW, ViewH, ViewMR;
extern MOOD		CurMood;
extern DWORD	CurPlayerNum, NumPlayers, maxID;
extern PLAYER	CurPlayer;
extern char		*iniPLAYER;
extern char		*iniNAME;
extern char		*iniMOOD;
extern char		*defHelp;
extern char		*defStrings;
extern DWORD	hGBMO;		// handle of ORIGINAL game graphics
extern long		GBMOwh;		// width/height of one tile in ORIGINAL game graphics
extern DWORD	hGBM;		// handle of GAME graphics SIZED
extern long		GU, GU15, GU2, GU25, GU6, GU8, GU9, GU10;	// various partial tile-widths (total tile is GU10xGU10, edge is GU, face is GU9xGU9)
extern DWORD	ClrHeadDark, ClrHeadLight;	// colors of top/bottom column header 'frame'
extern BOOL		DrawNumFirst;	// if image set wants NUMBERS drawn first on tile before CROC image
extern char		GBMOname[128];	// name of ORIGINAL game graphics file
extern QWORD	GBMtime;	// time of last modification of GBMO image set
extern BYTE		defactions[20];
extern DWORD	hSplashBM;
extern char 	PgmTitle[];
extern char		*PgmFolder;
extern char		*logname;
extern char		*iniFILENAME;
extern char		Copyright[];
extern char		MsgText[256];	// text buffer for MsgBar message
extern DWORD	MsgBackClr, MsgTextClr;
extern HWND		hMsgBar;	// handle of message bar dialog
extern HWND		hButtBar;	// handle of button bar dialog
extern BOOL		NeedDrawAll;	// mainDrawAll() needs to be done
extern DWORD	LastSoundTime;	// time last .WAV file was played, to keep them from walking all over each other
extern char		*FMTd;
extern char		*iniCURBUTT;
extern char		*iniCURPUZZNUM;
extern DLGRES	 TitleDlg[];
extern char		*defimgname;
extern BOOL		ShuttingDown;	// TRUE when hMain is being destroyed
extern BOOL		NeedNewGame;		// if "go to next puzzle" is pending because of PromptNewGame
extern long		ScriptState;		// 0 = nothing to do (see GameTimer() in game.c if any scripts are supported)
extern DWORD	hPuppyBM;	// handle of special win display graphics
extern BOOL		IsMainUp;
extern long 	cdy, BrdY;		
