#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/stat.h>

#include <windows.h>
#include <winbase.h>

#define	FALSE	0
#define	TRUE	1

#ifndef max
//#define max(a,b) (((a) > (b)) ? (a) : (b))
#define min(a,b) (((a) < (b)) ? (a) : (b))
#endif

#define	QWORD	unsigned long long	/// unsigned 8 bytes
#define	DWORD	unsigned long		/// unsigned 4 bytes
#define	WORD	unsigned short		/// unsigned 2 bytes
#define	BYTE	unsigned char		/// unsigned 1 byte
#define	BOOL	int					/// TRUE/FALSE

#define	MAXCODEBLOCK		(2048*1024)	/// (2 MB) # WORDS for code/variables memory block
#define	CODELIMIT			(MAXCODEBLOCK-1024)	/// give ourselves a little lee-way to prevent trashing memory without constantly checking every byte output
#define	MAXID				(256*1024)	/// max # of ID definitions
#define MAXIDLEN			31			/// maximum length of an identifier (in BYTES, not counting the terminating NUL) UTF-8 chars will shorten the available 'character'-length

///******************************************
typedef struct {
	QWORD	value;				/// address, equ, etc.
	DWORD	flags;				/// see IDF_ #defines below
	long	FilesIX;			/// source file# where this ID occurred (-1 until defined)
	char	name[MAXIDLEN+1];	/// name of the identifier
} IDSTRUCT;

typedef IDSTRUCT* IDPTR;

#define	IDF_UNUSED		0x0000
#define	IDF_BYTE		0x0001
#define	IDF_WORD		0x0002
#define	IDF_DWORD		0x0004
#define	IDF_QWORD		0x0008
#define	IDF_EXTERN		0x0010
#define	IDF_PUBLIC		0x0020
#define	IDF_MAPLABEL	0x0040	/// label is first after an 'align', dump it to the MAP file
#define	IDF_CODE		0x0080	/// code seg label
#define	IDF_UNDEFINED	0x0100	/// fwd-ref to identifier
#define	IDF_REFERENCED	0x0200	/// if id has been referenced from anywhere
#define	IDF_ZERO		0x0400	/// if goes in SEG_ZERO (i.e., uninitialized)

IDSTRUCT	IDtab[MAXID];		/// IDENTIFIERs table
long		IDcnt;				/// count of entries in the IDtab
long		ATcnt;				/// count for generating unique labels for ":@" labels in the form "_@#" where '#' is the formatted "ATcnt++"
								/// so any reference to '@B' will be replaced by a reference to label "_@#" where '#' is "ATcnt-1"
								/// and any reference to '@F' will be replaced by a reference to label "_@#" where '#' is "ATcnt"

DWORD	AlignLabel;				/// 0 or IDF_MAPLABEL, indicating if this is the first label after an 'align' and so should be dumped to the MAP file

BYTE	Code[MAXCODEBLOCK];		/// output object code buffer
BYTE	*pC;					/// pointer to next available WORDs in Code[]

#define	KINTrevYEAR		0xD6	/// NOTE: if the 'header' definition changes, these MUST be updated to match!!!
#define	KINTrevMONTH	0xD8
#define	KINTrevDAY		0xD9	/// YYYYMMDD of when the .KE was assembled
#define	KINTrevMAJOR	0xDA	/// publicly viewed MAJOR rev#
#define	KINTrevMINOR	0xDB	/// publicly viewed MINOR rev#
#define	KINTrevBUILD	0xDC	/// build#, set by KASM6 from text file BUILDNUM
#define	KINTlenCODE		0xE0	/// length of SEG_CODE
#define	KINTlenZERO		0xE8	/// length of SEG_ZERO

///******************************************
char	EOLseq[] = "\r\n";

char	ScratBuf[8192], FilesPath[512];

BOOL	quiet;					/// keeps a few messages from appearing on the console

DWORD	alignmask=0xFFFFFFFF;
WORD	alignsize=1;

long	ksize;
long	ksizelen[]={1,2,4,8};
long	ksizecon[]={4,4,4,8};
QWORD	ksizemask[]={0xFFFFFFFFFFFFFF00, 0xFFFFFFFFFFFF0000, 0xFFFFFFFF00000000, 0x0000000000000000};

long	ofh;		// object file handle
long	lfh;		// list file handle
char	ListBuf[1280], ListErrBuf[1280];
long	MaxListLen=116, TabWidth=4;
BYTE	*ListPC, *pC, *RecentAt;

DWORD	TotalCodeLen, TotalZeroLen;	/// known lengths set at end of first Pass
									/// during both passes, (pC-Code)=current code length, ZeroLen=current zero len
DWORD	ZeroLen;					/// current length of uninitialized variables area

char	tmperr[1280];
long	ErrCnt;					// error count

///******************************************
typedef struct {
	char	name[256];
	char	*pBuf;
} SRCFILE;

SRCFILE	Files[128];
long	FilesCnt=0;				/// number of source files linked together to comprise the .KE source
long	CurFile;				/// current file being processed

#define	PATHSEP		'\\'		/// path elements separator char
#define	DRIVESEP	':'			/// drive element separator char

///******************************************
char	SegChar=' ';			/// separator char for listing file, indicates the SEG we're in
long	CurSeg;

#define	SEG_NONE	0
#define	SEG_CODE	1
#define	SEG_ZERO	2

///******************************************
BYTE	*pIB;
BYTE	LineBuf[8192]="", *pLB=LineBuf, *pLBsave;
long	LineNum;
BOOL	NoListAddress;

long	Pass, ListPass0;
BOOL	GateErrors=FALSE;

char	HexChars[18] = "0123456789ABCDEF";

IDPTR	paID;
QWORD	paCONST;
long	paREG;

///******************************************
typedef struct {
	char	*name;
	void (*ASMfunc)(long);
	DWORD	code;
} OPDAT;

void ASMtstjmp(long);
void ASMcondjmp(long);
void ASMargless(long);
void ASMefr(long);
void ASMsfvr(long);
void ASMjsr(long);
void ASMjmp(long);
void ASMop1(long opix);
void ASMop2(long opix);
void ASMpushs(long);

#define	LEAIX		22
#define	MEMMOVIX	23
#define	PUMEMIX		30
#define	POMEMIX		31
#define	PUSHIX		52
#define	PEAIX		54
#define	CVIX		56
#define	JSRFRIX		90
#define	PUSHSIX		92

OPDAT	OPtab[] = {
	//NAME		FUNC		D,A			FP,A		D,FP		FP,FP
	{"divi",	&ASMop2,	0},		/// 0
	{"modi",	&ASMop2,	1},
	{"rshi",	&ASMop2,	2},
	{"divu",	&ASMop2,	3},
	{"modu",	&ASMop2,	4},
	{"rshu",	&ASMop2,	5},
	{"add",		&ASMop2,	6},
	{"sub",		&ASMop2,	7},
	{"cmp",		&ASMop2,	8},
	{"mul",		&ASMop2,	9},
	{"tst",		&ASMop2,	10},	/// 10
	{"lsh",		&ASMop2,	11},
	{"and",		&ASMop2,	12},
	{"or",		&ASMop2,	13},
	{"xor",		&ASMop2,	14},
	{"mov",		&ASMop2,	15},
	{"movz",	&ASMop2,	16},
	{"addf",	&ASMop2,	17},
	{"subf",	&ASMop2,	18},
	{"mulf",	&ASMop2,	19},
	{"divf",	&ASMop2,	20},	/// 20
	{"cmpf",	&ASMop2,	21},
	{"lea",		&ASMop2,	22},
	{"memmov",	&ASMop2,	23},
	{NULL,		&ASMop2,	24},
	{NULL,		&ASMop2,	25},
	{NULL,		&ASMop2,	26},
	{NULL,		&ASMop2,	27},
	{NULL,		&ASMop2,	28},
	{NULL,		&ASMop2,	29},
	{"pumem",	&ASMop2,	30},	/// 30
	{"pomem",	&ASMop2,	31},

	{"tljeq",	&ASMtstjmp,	0},
	{"tljne",	&ASMtstjmp,	1},
	{"tljge",	&ASMtstjmp,	2},
	{"tljgt",	&ASMtstjmp,	3},
	{"tljle",	&ASMtstjmp,	4},
	{"tljlt",	&ASMtstjmp,	5},
	{"tljev",	&ASMtstjmp,	6},
	{"tljod",	&ASMtstjmp,	7},

	{"ljeq",	&ASMcondjmp,0},	/// 40
	{"ljne",	&ASMcondjmp,1},
	{"ljge",	&ASMcondjmp,2},
	{"ljgt",	&ASMcondjmp,3},
	{"ljle",	&ASMcondjmp,4},
	{"ljlt",	&ASMcondjmp,5},
	{"ljev",	&ASMcondjmp,6},
	{"ljod",	&ASMcondjmp,7},

	{"negf",	&ASMop1,	0},
	{"neg",		&ASMop1,	1},
	{"not",		&ASMop1,	2},	/// 50
	{"tst",		&ASMop1,	3},
	{"push",	&ASMop1,	4},
	{"pop",		&ASMop1,	5},
	{"pea",		&ASMop1,	6},
	{NULL,		&ASMop1,	7},
	{"cvuu",	&ASMop1,	8},	/// 56
	{"cvss",	&ASMop1,	9},
	{"cvuf",	&ASMop1,	10},
	{"cvsf",	&ASMop1,	11},
	{"cvud",	&ASMop1,	12}, /// 60
	{"cvsd",	&ASMop1,	13},
	{"cvfs",	&ASMop1,	14},
	{"cvds",	&ASMop1,	15},
	{"cvfd",	&ASMop1,	16},
	{"cvdf",	&ASMop1,	17},
	{NULL,		&ASMop1,	18},
	{NULL,		&ASMop1,	19},
	{NULL,		&ASMop1,	20},
	{NULL,		&ASMop1,	21},
	{NULL,		&ASMop1,	22}, /// 70
	{NULL,		&ASMop1,	23},
	{NULL,		&ASMop1,	24},
	{NULL,		&ASMop1,	25},
	{NULL,		&ASMop1,	26},
	{NULL,		&ASMop1,	27},
	{NULL,		&ASMop1,	28},
	{NULL,		&ASMop1,	29},
	{NULL,		&ASMop1,	30},
	{NULL,		&ASMop1,	31},

	{"dbg",		&ASMargless,0}, /// 80
	{NULL,		&ASMargless,1},
	{"sys",		&ASMargless,2},
	{"brk",		&ASMargless,3},
	{"term",	&ASMargless,4},
	{"nop",		&ASMargless,5},
	{"smod",	&ASMargless,6},
	{"emod",	&ASMargless,7},
	{"efr",		&ASMefr,	0},
	{"sfvr",	&ASMsfvr,	0},
	{"jsrfr",	&ASMjsr,	0},	/// 90 JSR =, JSR $reg
	{"jmp",		&ASMjmp,	0},// JMP offset, JMP $reg,offset
	{"pushs",	&ASMpushs,	0},	/// 92
};

///******************************************************************
///******************************************************************
///******************************************************************
///******************************************************************
void ReportError(char *str) {

	if( !GateErrors || Pass ) {
		printf("%s(%ld): %s\n", Files[CurFile].name, LineNum, str);
		++ErrCnt;

		sprintf(ListErrBuf, " ***** %s(%ld): %s%s", Files[CurFile].name, LineNum, str, EOLseq);
		_write(lfh, ListErrBuf, strlen(ListErrBuf));
	}
}

///******************************************************************
void ReportErrorNoLine(char *str) {

	if( !GateErrors || Pass ) {
		printf("%s\n", str);
		++ErrCnt;

		sprintf(ListErrBuf, " ***** %s%s", str, EOLseq);
		_write(lfh, ListErrBuf, strlen(ListErrBuf));
	}
}

///********************************
IDPTR AddID(char *lab, QWORD value, WORD flags, long file) {

	IDPTR	pID;

//if( CurFile==2 && !strcmp(lab, "L30") ) {
//	pID = NULL;
//}
	if( IDcnt >= MAXID ) {
		ReportError("Size of ID table exceeded");
		return NULL;
	}
	pID = &IDtab[IDcnt];
	if( !Pass && (flags & (IDF_CODE | IDF_ZERO)) ) {
		++IDcnt;
		strcpy(pID->name, lab);
		pID->value = value;
		pID->flags = flags;
		pID->FilesIX = file;
	}
	return pID;
}

///********************************
/// IDs are CASE-SENSITIVE
IDPTR FindID(char *lab) {

	long	i;
	IDPTR	pID;

//if( CurFile==2 && !strcmp(lab, "L30") ) {
//	pID = NULL;
//}
	for(i=0; i<IDcnt; i++) {
		pID = &IDtab[i];
		if( !stricmp(lab, pID->name) ) {
			return pID;		/// if CurFile, return it
		}
	}
	return NULL;
}

#define	SkipWhite()	{while( *pLB && (*pLB==' ' || *pLB=='\t') ) ++pLB;}

///********************************
/// Gets the next non-comment line into LineBuf.
/// Lines which are ALL comment (first non-whitespace char is ';')
/// are skipped, but LineNum is incremented appropriately.
/// At exit, pLB points to the beginning of LineBuf, LineBuf is
/// null-terminated, and LineNum is the line number of the line
/// in LineBuf. If the end of one file is reached, the next file
/// is started, until the last file is completed.

#define	iLISTNAME		0
#define	iLISTLINENUM	9
#define	iLISTSEG		15
#define	iLISTADDRESS	17
#define	iLISTOBJWORDS	24
#define	iLISTSOURCE		51

WORD GetLine() {

	int		len;
	char	*pList;
	QWORD	addr;

	do {
		// check if any garbage left on previous line
		SkipWhite();
		if( *pLB && *pLB!=';' ) {	// something besides eol comment
			sprintf(tmperr, "unexpected characters: %s", pLB);
			ReportError(tmperr);
		}
		do {
			/// lines in the .KL file have this layout:
			///	FFFFFFFF:NNNNN S AAAAAA OOOO OOOO OOOO OOOO OOOO CCCCCCCCCCCCCCCC....
			///	FFFFFFFF:NNNNN S AAAAAA OOOOOOOO OOOOOOOO OOOOOOOO CCCCCCCCCCCCCCCC....
			///	where:
			///		FFFFFFFF	= first 8 chars of source file name
			///		NNNNN		= decimal line# of current file (mod 100000)
			///		S			= segment char (' ' for none, 'C' for Code, 'Z' for Zero)
			///		AAAAAA		= hex absolute address in .KE file
			///		OOOOOOOO	= DWORD of object code generated by this line, up to 3 DWORDs per line (additional lines may occur if >3 DWORDs generated)
			///		CCCCC...	= source code

			/// if Pass 2, add the just finished line to the .kl file
			if( (Pass || ListPass0) && LineNum>0 ) {	/// skip if just starting the file, don't have a line to list
				do {
					if( CurSeg==SEG_ZERO ) addr = TotalCodeLen + ZeroLen;
					else addr = (QWORD)(ListPC-Code);
					sprintf(ListBuf, "%8.8s:%5.5u %c %6.6lX ", Files[CurFile].name, (unsigned)(LineNum%100000), SegChar, (DWORD)addr);
					if( NoListAddress ) for(long i=0; i<6; i++) ListBuf[iLISTADDRESS+i] = ' ';
					ListBuf[iLISTOBJWORDS] = ' ';	/// restore SPACE where above sprintf() put a NUL at the end
					if( CurSeg==SEG_CODE ) {
						// output the CODE BYTES or spaces
						if( ListPC<pC ) {
							for(len=iLISTOBJWORDS; ListPC<pC && len<iLISTSOURCE; len+=9) {
								sprintf(ListBuf+len, "%8.8lX", *((DWORD *)ListPC));
								ListPC += 4;
								ListBuf[len+8] = ' ';	/// restore SPACE where above sprintf() put a NUL at the end
							}
						}
					}

					if( Pass ) _write(lfh, ListBuf, strlen(ListBuf));
					else {	/// must be ListPass0 option, so output it to standard out
						long	i;

						/// printf turns '\n' into system's EOLseq, so we need to get rid of whatever EOLseq we've already added on and replace it with a single '\n'
						for(i=strlen(ListBuf); i && (ListBuf[i]=='\r' || ListBuf[i]=='\n'); --i) ;
						if( ListBuf[i]!='\r' && ListBuf[i]!='\n' ) ++i;
						strcpy(ListBuf+i, "\n");

						printf(ListBuf);
					}

					sprintf(ListBuf+iLISTOBJWORDS, "                           %s", EOLseq);	/// don't show source line on any (possible) subsequent object-word-output-lines
				} while( CurSeg==SEG_CODE && ListPC<pC );
			}
			/// set the new ListPC for the upcoming line
			if( CurSeg==SEG_ZERO ) ListPC = Code+ZeroLen;
			else ListPC = pC;
			memset(ListBuf, ' ', iLISTSOURCE);
			pList = ListBuf+iLISTSOURCE;
	/*
			/// list leading blanks/tabs
			while( *pIB==' ' || *pIB=='\t' ) {
				if( *pIB==' ' ) *pList++ = *pIB;
				else do *pList++ = ' '; while( ((pList-ListBuf)-iLISTSOURCE) % TabWidth );
				pIB++;
			}
	*/
			/// while not at end-of-file
			if( *pIB ) {
				pLB = LineBuf;	/// init output buffer pointer
				/// add the formatted line to the LIST buffer while copying to the LINE buffer
				while( *pIB && *pIB!='\r' && *pIB!='\n' && (pLB-LineBuf+1)<sizeof(LineBuf) ) {
					*pLB++ = *pIB;
					// add char to LIST buffer, expanding TAB chars
					if( *pIB=='\t' ) do *pList++ = ' '; while( ((pList-ListBuf)-iLISTSOURCE) % TabWidth );
					else *pList++ = *pIB;
					pIB++;
				}
				*pList++ = 0;
				len = strlen(ListBuf);
				if( len+2 > MaxListLen ) len = MaxListLen-2;
				strcpy(ListBuf+len, EOLseq);

				*pLB++ = '\0';
				pLB = LineBuf;
				/// skip EOL chars and bump the LineNum
				if( *pIB=='\r' ) ++pIB;
				if( *pIB=='\n' ) {
					++pIB;
					++LineNum;
				}
				if( *pLB && *pLB!=';' ) return TRUE;	/// done, we have a non-comment, non-empty line
			}
		} while( *pIB );

		if( ++CurFile >= FilesCnt ) break;	/// move on to next file

		LineNum = 0;
		CurSeg = SEG_NONE;
		pIB = (BYTE*)Files[CurFile].pBuf;
		LineBuf[0] = 0;
		pLB = LineBuf;
	} while( TRUE );
	/// end-of-file, return FAILED to get line
	return FALSE;
}

///****************************************
BOOL GetComma() {

	SkipWhite();
	if( *pLB!=',' ) {
		ReportError("expected COMMA");
		return FALSE;
	}
	++pLB;
	return TRUE;
}

/// (UTF8) START
long decodeLen(unsigned char s) {

	///Assumes valid UTF-8. Nothing has more than 4 bytes with current Unicode definitions.
	if( s <= 0x7f ) return 1;
	if( s <= 0xbf ) return 1;	 ///Continuation byte! Let's just assume we'll sync up eventually.
	if( s <= 0xdf ) return 2;
	if( s <= 0xef ) return 3;
	if( s <= 0xf7 ) return 4;
	///ERROR HERE - UTF-8 is not defined for more than 4 bytes per codepoint, but let's just assume everything syncs up eventually.
	return 1;
}

long decodeChar(unsigned char* s) {

  ///Assumes valid UTF-8.
  long	numChars = decodeLen(*s);

  if( numChars == 1 ) return s[0];
  long	result = s[0] & ((1 << (8-numChars))-1);
  for(long i=1; i < numChars; i++) result = (result<<6) | (s[i] & 0x3f);
  return result;
}
/// (UTF8) END

///**********************************
/// looks through LineBuf starting at pLB for a "word"
/// leading white space is skipped
/// "words" are terminated by any non-alphanumeric char.
/// "words" can START with '&' '@' ':' '-' "::" or an alphanumeric char.
/// Returns TRUE if one found, FALSE if not (eol, with comments skipped)
/// If first non-white space character encountered is non-token-char,
/// then FALSE is returned with pLB unmoved.
BOOL GetToken(char *buf) {

	char	*pOut, c;
	long	len;

	pLBsave = pLB;
	pOut = buf;
	SkipWhite();
	if( *pLB==';' ) {	// skip comment
		while( *pLB ) ++pLB;
	} else {	// else get possible word
		c = *pLB;
		if( c=='&' ) *pOut++ = *pLB++;
		else if( c=='@' || c==':' || c=='-' || c=='_' || isalnum(c) ) {	/// only allow as first char. Otherwise, it's the end of what's come before
			*pOut++ = *pLB++;
			if( c==':' && *pLB=='@' ) {	/// ":@" label?
				*pOut++ = *pLB++;	/// copy the '@'
			} else {
				/// (UTF8) START
				/// get the whole identifier (as long as letter or digit)
				do {
					if( *pLB=='_' || isalnum(*pLB) ) *pOut++ = *pLB++;
					else if( *pLB>=0300 && *pLB<0370 ) {
						if( iswalnum(decodeChar(pLB)) ) {
							len = decodeLen(*pLB);
							while( len-- ) *pOut++ = *pLB++;
						} else break;	/// UTF8 char, but not alnum, so terminate identifier
					} else break;		/// not alnum nor underscore nor UTF8, so terminate identifier
				} while( TRUE );
				/// (UTF8) END
			}
		}
	}
	*pOut = '\0';
	SkipWhite();
	if( *buf ) return TRUE;
	return FALSE;
}

///********************************
QWORD a2n(char *buf) {

	QWORD	result;
	char	*p, c;
	BOOL	neg=FALSE;

	result = 0;
	p = buf;
	if( *p=='-' ) {
		++p;
		neg = TRUE;
	}
	if( *p=='0' ) {	// octal or hex
		++p;
		if( toupper(*p)=='X' ) {	// hex value
			++p;
			while( isxdigit(*p) ) {
				c = toupper(*p++);
				if( c>='A' && c<='F' ) c -= 7;
				c -= '0';
				result = 16*result + (QWORD)c;
			}
		} else {	// octal value
			while( *p>='0' && *p<='7' ) {
				c = *p++;
				c -= '0';
				result = 8*result + (QWORD)c;
			}
		}
	} else {	// decimal value
		while( isdigit(*p) ) {
			c = *p++;
			c -= '0';
			result = 10*result + (QWORD)c;
		}
	}
	if( *p ) {
		sprintf(tmperr, "invalid number: %s", buf);
		ReportError(tmperr);
	}
	if( neg ) result = (QWORD)(-(unsigned long long)result);
	return result;
}

///********************************
WORD IsComma() {

	WORD	retval=FALSE;

	SkipWhite();
	if( *pLB==',' ) {
		retval = TRUE;
		++pLB;
		SkipWhite();
	}
	return retval;
}

///********************************
WORD GetChar(char c) {

	SkipWhite();
	if( *pLB!=(BYTE)c ) {
		sprintf(tmperr, "expected '%c'", c);
		ReportError(tmperr);
		return FALSE;
	}
	++pLB;
	return TRUE;
}

///********************************
char PeekChar() {

	SkipWhite();
	return (char)(*pLB);
}

///*************************************
void align() {

	if( CurSeg==SEG_CODE ) {
		// alignmask = 0,1,3,7
		// output 0-val bytes until aligned
		while( (pC-Code) & alignmask ) *pC++ = 0;
	} else if( CurSeg==SEG_ZERO ) {
		while( ZeroLen & alignmask ) ++ZeroLen;
	} else {
		ReportError("Invalid ALIGN attempt");
	}
}

///**************************************
void ForceAlign(int a) {

	if( a==1 || a==2 || a==4 || a==8 ) alignsize = a;
	else {
		sprintf(tmperr, "Critical KASM error: ForceAlign(%d)", a);
		ReportError(tmperr);
		return;
	}
	alignmask = alignsize-1;
	// alignmask =
	//	0 for align(1)
	//	1 for align(2)
	//	3 for align(4)
	//	7 for align(8)
	align();
}

///************************************
int ParseAlign() {

	if( !GetToken(ScratBuf) || ScratBuf[1] || (*ScratBuf!='1' && *ScratBuf!='2' && *ScratBuf!='4' && *ScratBuf!='8') ) {
		sprintf(tmperr, "1, 2, 4, or 8 expected: %s", pLB);
		ReportError(tmperr);
		return 1;
	}
	ForceAlign(ScratBuf[0]-'0');
	return 0;
}

///**********************************************************************************************
/// Chews up any combination of + and - constant values +/- ONE optional ID
BOOL GetExp() {

	BOOL	neg=FALSE;
	QWORD	qv;
	long	atoff;

	paCONST = 0;
	paID = NULL;

	SkipWhite();
	if( *pLB=='-' ) {
		++pLB;
		neg = TRUE;
	} else if( *pLB=='+' ) ++pLB;

	do {
		if( !GetToken(ScratBuf) ) {
geerr:
			ReportError("invalid expression");
			return FALSE;
		}
		if( isdigit(ScratBuf[0]) ) {	/// chew up literal number
			qv = a2n(ScratBuf);
			if( neg ) qv = (QWORD)(-(long long)qv);
			paCONST += qv;
		} else if( paID!=NULL ) goto geerr;
		else {		/// chew up identifier
			if( Pass ) {
				if( ScratBuf[0]=='@' ) {
					atoff = 0;
					if( toupper(ScratBuf[1])=='F' ) {
						while( toupper(ScratBuf[1+atoff])=='F' ) ++atoff;
						if( ScratBuf[1+atoff] ) {
badat:
							ReportError("bad @label_reference");
							return FALSE;
						}
						sprintf(ScratBuf, "_@%ld", ATcnt-1+atoff);
					} else if( toupper(ScratBuf[1])=='B' ) {
						while( toupper(ScratBuf[1+atoff])=='B' ) ++atoff;
						if( ScratBuf[1+atoff] ) goto badat;
						sprintf(ScratBuf, "_@%ld", ATcnt-atoff);
					}
				}
				if( NULL==(paID=FindID(ScratBuf)) ) {
					sprintf(ScratBuf+100,"undefined label: %s", ScratBuf);
					ReportErrorNoLine(ScratBuf+100);
					return FALSE;
				}
				if( neg ) paCONST -= paID->value;
				else paCONST += paID->value;
			} else {
				/// first pass, don't care what value is pushed
				/// it will get corrected on the second pass
				/// we just need paID to be non-NULL
				if( NULL==(paID=FindID(ScratBuf)) ) paID = AddID(ScratBuf, 0, IDF_UNDEFINED, -1);
			}
		}
		SkipWhite();
		if( *pLB!='+' && *pLB!='-' ) return TRUE;
		neg = (*pLB=='-');
		++pLB;
	} while( TRUE );
}

///**********************************************************************************************
/// to be a register name, must:
///		1) start with '$'
///		2) the second and/or third characters must be "0" through "23"
///		3) the next character must not be a valid identifier character (alpha, numeric, or '_')
/// returns 0 if pLB doesn't point to a register name, or len of register name if it does
long isreg() {

	if( *pLB=='$' ) {
		if( *(pLB+1)>='0' && *(pLB+1)<='9' ) {
			if( (*(pLB+1)=='1' && *(pLB+2)>='0' && *(pLB+2)<='9') || (*(pLB+1)=='2' && *(pLB+2)>='0' && *(pLB+2)<='3') ) {
				if( !isalnum(*(pLB+3)) && *(pLB+3)!='_' ) return 3;
			} else if( !isalnum(*(pLB+2)) && *(pLB+2)!='_') return 2;
		}
	}
	return 0;
}

///************************************
/// Returns register # (0-23) if pLB points to a register reference, else returns -1.
long getreg() {

	long	rlen, rnum;

	if( (rlen=isreg()) ) {
		rnum = atol((char*)pLB+1);
		pLB += rlen;
		return rnum;
	}
	return -1;
}

///************************************
/// chew up major addressing modes, set the global arguments, return the mode or -1 if errors (already reported)
/// Mode is 0-32, where:
///		-1		fatal syntax error
///		0-15	reg#
///		16-31	[reg#][con] (just "[reg#]" is accepted, with 'con' defaulted to '0')
///		32		[con]
///		33		=con
///		34		[FP][con]
///
long GetA() {

	long	retval;
	BYTE	*savePLB;

	paCONST = 0;	/// default for [reg] to look like [reg][0]
	SkipWhite();
	// REG?
	if( (retval=getreg())>=0 ) return (paREG = retval);	// return 0-23
	else if( *pLB=='[' ) {	/// not register, not constant
		savePLB = pLB;	/// in case just [const] and we need to backup
		++pLB;	/// skip '['
		SkipWhite();
		if( isreg() ) {	/// [reg][const]
			paREG = getreg();
			SkipWhite();
			if( *pLB!=']' ) goto aerr;
			++pLB;
			SkipWhite();
			if( *pLB=='[' ) {	/// must be [reg][const]
				++pLB;
				if( !GetExp() ) goto aerr;	/// chew up CONST (which may be an expression and MAY contain an IDENTIFIER, which will get stuck in paID);
				SkipWhite();
				if( *pLB!=']' ) goto aerr;
				++pLB;
			}
			return 16+paREG;		/// mode 16-31 = [reg][const]
		} else {	/// [FP]-something or [const]
			SkipWhite();
			if( toupper(*pLB)=='F' && toupper(*(pLB+1))=='P' ) {	/// [FP][const]
				pLB += 2;
				SkipWhite();
				if( *pLB!=']' ) goto bracketconst;
				++pLB;
				SkipWhite();
				if( *pLB!='[' ) goto aerr;
				retval = 34;		/// mode 34 = [FP][const]
			} else {				/// [const], hopefully
bracketconst:
				pLB = savePLB;		/// back up to the opening '['
				retval = 32;
			}
			/// get [const] for modes 32, 34
			SkipWhite();
			if( *pLB!='[' ) goto aerr;
			++pLB;
			if( !GetExp() ) goto aerr;	/// chew up CONST (which may be an expression and MAY contain an IDENTIFIER, which will get stuck in paID);
			SkipWhite();
			if( *pLB!=']' ) goto aerr;
			++pLB;
			return retval;	/// return either 32 or 34
		}
	} else if( *pLB=='=' ) {	/// =const
		++pLB;
		if( !GetExp() ) goto aerr;
		retval = 33;							/// =const
		return retval;
	}
aerr:
	ReportError("invalid addressing mode");
	return -1;	/// fatal error
}

///************************************
	///0000 0000 0000 AAAA CCCC CSSD DDD1 1100				OP2 $,$
	///0000 0000 0000 AAAA CCCC CSSD DDD0 0010 Dcon			OP2 [$][con],$
	///0000 0000 0000 AAAA CCCC CSSD DDD1 0010 Acon			OP2 $,[$][con]
	///0000 0000 0000 AAAA CCCC CSSD DDD0 1010 Dcon Acon	OP2 [$][con],[$][con]
	///0000 0000 0000 0000 CCCC CSSD DDD1 1010 Acon			OP2 $,[con]
	///0000 0000 0000 0000 CCCC CSSD DDD0 0110 Dcon Acon	OP2 [$][con],[con]
	///0000 0000 0000 0000 CCCC CSSD DDD1 0110 Acon			OP2 $,=con
	///0000 0000 0000 0000 CCCC CSSD DDD0 1110 Dcon Acon	OP2 [$][con],=con
	///0000 0000 0000 ssss CCCC CSSD DDD1 1110 				OP2 $,=sCon (sss is -8 to +7)
	///0000 0000 0000 ssss CCCC CSSD DDD0 0001 Dcon			OP2 [$][con],=sCon (sss is -8 to +7)
	///aaaa aaaa aaaa aaaa CCCC CSSD DDD1 0001				OP2 $,[FP][con16]
	///aaaa aaaa aaaa aaaa CCCC CSSD DDD0 1001 Dcon			OP2 [$][con],[FP][con16]
	///0000 0000 0000 0000 CCCC CSSA AAA1 1001 Dcon			OP2 [con],$
	///0000 0000 0000 0000 CCCC CSSA AAA0 0101 Dcon Acon	OP2 [con],[$][con]
	///0000 0000 0000 0000 CCCC CSS- ---1 0101 Dcon Acon	OP2 [con],[con]
	///0000 0000 0000 0000 CCCC CSS- ---0 1101 Dcon Acon	OP2 [con],=con
	///0000 0000 0000 0000 CCCC CSSs sss1 1101 Dcon 		OP2 [con],=sCon (sss is -8 to +7)
	///aaaa aaaa aaaa aaaa CCCC CSS- ---0 0011 Dcon			OP2 [con],[FP][con16]
	///dddd dddd dddd dddd CCCC CSSA AAA1 0011 				OP2 [FP][con16],$
	///dddd dddd dddd dddd CCCC CSSA AAA0 1011 Acon			OP2 [FP][con16],[$][con]
	///dddd dddd dddd dddd CCCC CSS- ---1 1011 Acon			OP2 [FP][con16],[con]
	///dddd dddd dddd dddd CCCC CSS- ---0 0111 Acon			OP2 [FP][con16],=con
	///dddd dddd dddd dddd CCCC CSSs sss1 0111 				OP2 [FP][con16],=sCON (sss is -8 to +7)
	///dddd dddd dddd dddd CCCC CSS- ---0 1111 Acon			OP2 [FP][con16],[FP][con]

///		-1		fatal syntax error
///		0-15	$
///		16-31	[$][con]
///		32		[con]
///		33		=con
///		34		[FP][con]

void ASMop2(long opix){

	long	amode, dmode, dREG;
	QWORD	dCONST;
	DWORD	op=0;
	BYTE	*spC;

	dmode = GetA();

	if( dmode < 0 ) return;	// if -1, error already reported

	if( opix!=PUMEMIX && opix!=POMEMIX && dmode==33 ) {	/// immediate const value is illegal for D target EXCEPT for PUMEM/POMEM where D is the # of bytes
		ReportError("illegal destination addressing mode");
		return;
	}

	dREG  = paREG;
	dCONST= paCONST;

	spC = pC;
	pC += 4;

	if( !GetComma() ) return;
	amode = GetA();
	if( amode < 0 ) return;	// if -1, error already reported

	if( (opix==LEAIX || opix==MEMMOVIX || opix==PUMEMIX || opix==POMEMIX) && (amode<16 || amode==33) ) {	/// reg# and immediate value are illegal
		ReportError("invalid argument addressing mode");
		return;
	}

	if( (dmode==34 && ((long long)dCONST < -32768 || (long long)dCONST > 32767))
	 || (amode==34 && ((long long)paCONST < -32768 || (long long)paCONST > 32767)) ) {
		ReportError("stack offset overflow");
		return;
	}

	if( dmode < 16 ) {				/// DDDDD = $
	   if( amode < 16 ) {			/// AAAAA = $
			///0000 0000 0000 AAAA CCCC CSSD DDD1 1100				OP2 $,$
			op = 0x0000001C | (paREG<<16) | (dREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// $,$
		} else if( amode==34 ) {	/// AAAAA = [FP][a]
			///aaaa aaaa aaaa aaaa CCCC CSSD DDD1 0001				OP2 $,[FP][con16]
			op = 0x00000011 | (paCONST<<16) | (dREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// $,[FP][a]
		} else if( amode<32 /*already tested for <16 above*/ ) {	/// AAAAA = [$][con]
			///0000 0000 0000 AAAA CCCC CSSD DDD1 0010 Acon			OP2 $,[$][con]
			op = 0x00000012 | (paREG<<16) | (dREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// $,[$][con]
			*(DWORD*)pC = paCONST;
			pC += 4;
		} else if( amode==32 ) {	/// AAAAA = [con]
			///0000 0000 0000 0000 CCCC CSSD DDD1 1010 Acon			OP2 $,[con]
			op = 0x0000001A | (dREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// $,[con]
			*(DWORD*)pC = paCONST;
			pC += 4;
		} else if( amode==33 ) {	/// AAAAA = =const
			if( paID==NULL && (long long)paCONST >= -4 && (long long)paCONST < 4 ) {	/// fits in smallCon
				///0000 0000 0000 ssss CCCC CSSD DDD1 1110 				OP2 $,=sCon (sss is -8 to +7)
				op = 0x0000001E | ((paCONST & 0x0F)<<16) | (dREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// $,=sCon
			} else {										/// else 32-bit con
				///0000 0000 0000 0000 CCCC CSSD DDD1 0110 Acon			OP2 $,=con
				op = 0x00000016 | (dREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// $,[con]
				*(DWORD*)pC = paCONST;
				pC += ksizecon[ksize];
			}
		}
	} else if( dmode==34 ) {	/// DDDDD = [FP][con]
	   if( amode < 16 ) {			/// AAAAA = $
			///dddd dddd dddd dddd CCCC CSSA AAA1 0011 				OP2 [FP][con16],$
			op = 0x00000013 | (dCONST<<16) | (paREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// [FP][con],$
		} else if( amode==34 ) {	/// AAAAA = [FP][Acon]
			///dddd dddd dddd dddd CCCC CSS- ---0 1111 Acon			OP2 [FP][con16],[FP][con]
			op = 0x0000000F | (dCONST<<16) | (ksize<<9) | (OPtab[opix].code<<11);	/// [FP][con],[FP][Acon]
			*(DWORD*)pC = paCONST;
			pC += 4;
		} else if( amode<32 ) {	/// AAAAA = [$][con]
			///dddd dddd dddd dddd CCCC CSSA AAA0 1011 Acon			OP2 [FP][con16],[$][con]
			op = 0x0000000B | (dCONST<<16) | (paREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// [FP][con],[$][con]
			*(DWORD*)pC = paCONST;
			pC += 4;
		} else if( amode==32 ) {	/// AAAAA = [con]
			///dddd dddd dddd dddd CCCC CSS- ---1 1011 Acon			OP2 [FP][con16],[con]
			op = 0x0000001B | (dCONST<<16) | (ksize<<9) | (OPtab[opix].code<<11);	/// [FP][con],[con]
			*(DWORD*)pC = paCONST;
			pC += 4;
		} else if( amode==33 ) {	/// AAAAA = =con
			if( paID==NULL && (long long)paCONST >= -4 && (long long)paCONST < 4 ) {
				///dddd dddd dddd dddd CCCC CSSs sss1 0111 				OP2 [FP][con16],=sCON (sss is -8 to +7)
				op = 0x00000017 | (dCONST<<16) | ((paCONST & 0x0F)<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// [FP][con],=sCon
			} else {
				///dddd dddd dddd dddd CCCC CSS- ---0 0111 Acon			OP2 [FP][con16],=con
				op = 0x00000007 | (dCONST<<16) | (ksize<<9) | (OPtab[opix].code<<11);	/// [FP][con],=con
				*(DWORD*)pC = paCONST;
				pC += 4;
			}
		}
	} else if( dmode < 32 ) {	/// DDDDD = [$][con]
	   if( amode < 16 ) {			/// AAAAA = $
			///0000 0000 0000 AAAA CCCC CSSD DDD0 0010 Dcon			OP2 [$][con],$
			op = 0x00000002 | (paREG<<16) | (dREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// [$][con],$
			*(DWORD*)pC = dCONST;
			pC += 4;
		} else if( amode==34 ) {	/// AAAAA = [FP][a]
			///aaaa aaaa aaaa aaaa CCCC CSSD DDD0 1001 Dcon			OP2 [$][con],[FP][con16]
			op = 0x00000009 | (paCONST<<16) | (dREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// [$][con],[FP][a]
			*(DWORD*)pC = dCONST;
			pC += 4;
		} else if( amode < 32 ) {	/// AAAAA = [$][con]
			///0000 0000 0000 AAAA CCCC CSSD DDD0 1010 Dcon Acon	OP2 [$][con],[$][con]
			op = 0x0000000A | (paREG<<16) | (dREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// [$][con],[$][con]
			*(DWORD*)pC = dCONST;
			pC += 4;
			*(DWORD*)pC = paCONST;
			pC += 4;
		} else if( amode==32 ) {	/// AAAAA = [con]
			///0000 0000 0000 0000 CCCC CSSD DDD0 0110 Dcon Acon	OP2 [$][con],[con]
			op = 0x00000006 | (dREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// [$][con],[Acon]
			*(DWORD*)pC = dCONST;
			pC += 4;
			*(DWORD*)pC = paCONST;
			pC += 4;
		} else if( amode==33 ) {	/// AAAAA = =con
			if( paID==NULL && (long long)paCONST >= -4 && (long long)paCONST < 4 ) {
				///0000 0000 0000 ssss CCCC CSSD DDD0 0001 Dcon			OP2 [$][con],=sCon (sss is -8 to +7)
				op = 0x00000001 | ((paCONST & 0x0F)<<16) | (dREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// [FP][con],=sCon
				*(DWORD*)pC = dCONST;
				pC += 4;
			} else {
				///0000 0000 0000 0000 CCCC CSSD DDD0 1110 Dcon Acon	OP2 [$][con],=con
				op = 0x0000000E | (dREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// [FP][con],=con
				*(DWORD*)pC = dCONST;
				pC += 4;
				*(DWORD*)pC = paCONST;
				pC += 4;
			}
		}
	} else if( dmode==32 ) {	/// DDDDD = [con]
	   if( amode < 16 ) {			/// AAAAA = $
			///0000 0000 0000 0000 CCCC CSSA AAA1 1001 Dcon			OP2 [con],$
			op = 0x00000019 | (paREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// [con],$
			*(DWORD*)pC = dCONST;
			pC += 4;
		} else if( amode==34 ) {	/// AAAAA = [FP][a]
			///aaaa aaaa aaaa aaaa CCCC CSS- ---0 0011 Dcon			OP2 [con],[FP][con16]
			op = 0x00000003 | (paCONST<<16) | (ksize<<9) | (OPtab[opix].code<<11);	/// [con],[FP][a]
			*(DWORD*)pC = dCONST;
			pC += 4;
		} else if( amode<32 ) {	/// AAAAA = [$][con]
			///0000 0000 0000 0000 CCCC CSSA AAA0 0101 Dcon Acon	OP2 [con],[$][con]
			op = 0x00000005 | (paREG<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// [con],[$][con]
			*(DWORD*)pC = dCONST;
			pC += 4;
			*(DWORD*)pC = paCONST;
			pC += 4;
		} else if( amode==32 ) {	/// AAAAA = [con]
			///0000 0000 0000 0000 CCCC CSS- ---1 0101 Dcon Acon	OP2 [con],[con]
			op = 0x00000015 | (ksize<<9) | (OPtab[opix].code<<11);	/// [con],[con]
			*(DWORD*)pC = dCONST;
			pC += 4;
			*(DWORD*)pC = paCONST;
			pC += 4;
		} else if( amode==33 ) {	/// AAAAA = =const
			if( paID==NULL && (long long)paCONST >= -4 && (long long)paCONST < 4 ) {
				///0000 0000 0000 0000 CCCC CSSs sss1 1101 Dcon 		OP2 [con],=sCon (sss is -8 to +7)
				op = 0x0000001D | ((paCONST & 0x0F)<<5) | (ksize<<9) | (OPtab[opix].code<<11);	/// [con],=sCon
				*(DWORD*)pC = dCONST;
				pC += 4;
			} else {
				///0000 0000 0000 0000 CCCC CSS- ---0 1101 Dcon Acon	OP2 [con],=con
				op = 0x0000000D | (ksize<<9) | (OPtab[opix].code<<11);	/// [con],=con
				*(DWORD*)pC = dCONST;
				pC += 4;
				*(QWORD*)pC = paCONST;
				pC += ksizecon[ksize];
			}
		}
	}
	*(DWORD*)spC = op;	/// store final opcode DWORD before any following arguments
}

///************************************
	///---- ---- ---- DDDD 0CCC CCSS 1101 0100				OP1 $
	///aaaa aaaa aaaa aaaa 0CCC CCSS 1010 1100				OP1 [FP][con16]
	///---- ---- ---- DDDD 0CCC CCSS 0110 1100 Dcon			OP1 [$][con]
	///---- ---- ---- ---- 0CCC CCSS 1110 1100 Dcon			OP1 [con]
	///---- ---- ---- ---- ---- --SS 0111 0100	Acon		PUSH =con
	///vvvv vvvv vvvv vvvv vvvv vvSS 1111 0100				PUSHS =con from (-2M) to (+2M-1)

///		-1		fatal syntax error
///		0-15	$
///		16-31	[$][con]
///		32		[con]
///		33		=con
///		34		[FP][con]
void ASMop1(long opix){

	long	amode;

	amode = GetA();
	if( amode < 0 ) return;	/// if -1, error already reported

	if( amode < 16 ) {	/// $
		///---- ---- ---- DDDD 0CCC CCSS 1101 0100				OP1 $
		if( opix==PEAIX ) {
iam:
			ReportError("invalid addressing mode");
		} else *(DWORD*)pC = 0x000000D4 | (paREG<<16) | (ksize<<8) | (OPtab[opix].code<<10);
	} else if( amode < 32 ) {	/// [$][con]
		///---- ---- ---- DDDD 0CCC CCSS 0110 1100 Dcon			OP1 [$][con]
		*(DWORD*)pC = 0x0000006C | (paREG<<16) | (ksize<<8) | (OPtab[opix].code<<10);
		pC += 4;
		*(DWORD*)pC = (DWORD)paCONST;
	} else if( amode==32 ) {	/// [con]
		///---- ---- ---- ---- 0CCC CCSS 1110 1100 Dcon			OP1 [con]
		*(DWORD*)pC = 0x000000EC | (ksize<<8) | (OPtab[opix].code<<10);
		pC += 4;
		*(DWORD*)pC = (DWORD)paCONST;
	} else if( amode==33 ) {	/// =con
		if( opix==PEAIX ) goto iam;
		if( opix==PUSHIX ) {
			if( ksize==0 ) {
				ReportError("b push is illegal");
				return;
			}
			if( paID==NULL && (long long)paCONST >= -2097152LL && (long long)paCONST < 2097152LL ) {	/// if PUSH =const and const will fit in PUSHS range
				///vvvv vvvv vvvv vvvv vvvv vvSS 1111 0100				PUSHS =con from (-2M) to (+2M-1)
				*(DWORD*)pC = 0x000000F4 | (ksize<<8) | ((paCONST & 0x003FFFFF)<<10);	/// push out the PUSHS instruction instead with the built-in value
			} else {
				///---- ---- ---- ---- ---- --SS 0111 0100	Acon		PUSH =con
				*(DWORD*)pC = 0x00000074 | (ksize<<8);	/// push out the PUSHS instruction instead with the built-in value
				pC += 4;
				*(QWORD*)pC = (DWORD)paCONST;
				pC += ksizecon[ksize]-4;	/// -4 because it will get added below
			}
		} else {	/// all opix =con EXCEPT for PEA and PUSH
			goto iam;
		}
	} else if( amode==34 ) {	/// [FP][con]
		if( (long long)paCONST < -32768 || (long long)paCONST > 32767 ) {
			ReportError("stack offset overflow");
			return;
		}
		///aaaa aaaa aaaa aaaa 0CCC CCSS 1010 1100				OP1 [FP][con16]
		*(DWORD*)pC = 0x000000AC | (paCONST<<16) | (ksize<<8) | (OPtab[opix].code<<10);
	}
	pC += 4;
}

///************************************
	///xxxx xxxx xxxx xxxx xxxx xxCC CSS0 0000 reg		TLJ $,=x		(DWORD address)
	///xxxx xxxx xxxx xxxx xxxx xxCC CSS1 0000 reg		TLJ [$],=x		(DWORD address)
	///xxxx xxxx xxxx xxxx xxxx xxCC CSS0 1000 Dcon		TLJ [con],=x	(DWORD address)
	///xxxx xxxx xxxx xxxx xxxx xxCC CSS1 1000 Dcon		TLJ [FP][con],=x (DWORD address)

///		-1		fatal syntax error
///		0-15	$
///		16-31	[$][con]
///		32		[con]
///		33		=con
///		34		[FP][con]
void ASMtstjmp(long opix){

	long	dmode, dREG;
	QWORD	dCONST;

	dmode = GetA();
	if( dmode<0 ) return;

	dCONST = paCONST;
	dREG   = paREG;
	if( !GetComma() ) return;
	SkipWhite();
	if( *pLB++ != '=' || !GetExp() ) {
		ReportError("bad jump target");
		return;
	}
	if( dmode==34 ) {	/// [FP][con],=x
		if( (long long)dCONST < -32768 || (long long)dCONST > 32767 ) {
			ReportError("stack offset overflow");
			return;
		}
		///xxxx xxxx xxxx xxxx xxxx xxCC CSS1 1000 Dcon		TLJ [FP][con],=x (DWORD address)
		*(DWORD*)pC = 0x00000018 | ((paCONST>>2)<<10) | (ksize<<5) | (OPtab[opix].code<<7);
		pC += 4;
		*(DWORD*)pC = (DWORD)dCONST;
		pC += 4;
	} else if( dmode==32 ) {	/// [con],=x
		///xxxx xxxx xxxx xxxx xxxx xxCC CSS0 1000 Dcon		TLJ [con],=x	(DWORD address)
		*(DWORD*)pC = 0x00000008 | ((paCONST>>2)<<10) | (ksize<<5) | (OPtab[opix].code<<7);
		pC += 4;
		*(DWORD*)pC = (DWORD)dCONST;
		pC += 4;
	} else if( dmode < 16 ) {	/// $,=x
		///xxxx xxxx xxxx xxxx xxxx xxCC CSS0 0000 reg		TLJ $,=x		(DWORD address)
		*(DWORD*)pC = 0x00000000 | ((paCONST>>2)<<10) | (ksize<<5) | (OPtab[opix].code<<7);
		pC += 4;
		*(DWORD*)pC = (DWORD)dREG;
		pC += 4;
	} else if( dmode < 32 ) {	/// [$],=x
		///xxxx xxxx xxxx xxxx xxxx xxCC CSS1 0000 reg		TLJ [$],=x		(DWORD address)
		*(DWORD*)pC = 0x00000010 | ((paCONST>>2)<<10) | (ksize<<5) | (OPtab[opix].code<<7);
		pC += 4;
		*(DWORD*)pC = (DWORD)dREG;
		pC += 4;
	} else {
		ReportError("invalid addressing mode");
	}
}

///************************************
///xxxx xxxx xxxx xxxx xxxx xxCC C011 0100				LJ =x			 (DWORD address)
void ASMcondjmp(long opix){

	SkipWhite();
	if( *pLB == '=' ) ++pLB;
	if( !GetExp() ) {
		ReportError("bad jump target");
		return;
	}
	///xxxx xxxx xxxx xxxx xxxx xxCC C011 0100				LJ =x			 (DWORD address)
	*(DWORD*)pC = 0x00000034 | ((paCONST>>2)<<10) | (OPtab[opix].code<<7);
	pC += 4;
}

///************************************
///---- ---- ---- ---- ---- -CCC C001 0100 	 		x/x/SYS/BRK/TERM/NOP/SMOD/EMOD
void ASMargless(long opix) {

	///---- ---- ---- ---- ---- -CCC C001 0100 	 		x/x/SYS/BRK/TERM/NOP/SMOD/EMOD/DBG/unused
	*(DWORD*)pC = 0x00000014 | (OPtab[opix].code<<7);
	pC += 4;
}

///************************************
///---v vvvv vvvv vvvv vvrr rr01 0101 0100 		 	SFVR var_local_size,reg_save_count (starting at $13 and working downward)
void ASMsfvr(long opix) {

	QWORD	qv, qr;

	/// get size of variables
	if( !GetToken(ScratBuf) ) ReportError("missing variables size");
	else {
		qv = a2n(ScratBuf);
		if( qv & 0xFFFFFFFFFFFF0000 ) ReportError("invalid variable size");
		else {
			if( GetComma() ) {
				if( !GetToken(ScratBuf) ) ReportError("missing register count");
				else {
					qr = a2n(ScratBuf);
					if( qr > 14 ) ReportError("invalid register count");
					else {
						/// we only shift the register mask 4 instead of 5 because the LSbit of the mask isn't used, so we want bits 1-14 (bit 0 is ALWAYS 0 from KRCC)
						///---v vvvv vvvv vvvv vvrr rr01 0101 0100 		 	SFVR var_local_size,reg_save_count (starting at $13 and working downward)
						*(DWORD*)pC = 0x00000154 | (((DWORD)qv)<<14) | (((DWORD)qr)<<10);
						pC += 4;	/// skip opcode
					}
				}
			}
		}
	}
}

///************************************
///0000 0000 0000 0000 0rrr rr10 0101 0100 			EFR r (where 'r' is the register restore count, starting at $13-r+1 and working upward)
void ASMefr(long opix) {

	QWORD	qv;

	if( !GetToken(ScratBuf) ) ReportError("missing register count");
	else {
		qv = a2n(ScratBuf);
		if( qv > 14 ) ReportError("invalid register count");
		else {
			*(DWORD*)pC = 0x00000254 | (((DWORD)qv)<<10);
			pC += 4;
		}
	}
}

///************************************
///ffff ffff ffff ffff AAAA -011 0101 0100				JSRFR f,$
///ffff ffff ffff ffff ---- --00 0101 0100 Acon		JSRFR f,=con	(BYTE address)
void ASMjsr(long opix){

	long	dmode;
	QWORD	qv;

	if( !GetToken(ScratBuf) || !isdigit(ScratBuf[0]) ) {
		ReportError("missing stack arguments size");
		return;
	}
	qv = a2n(ScratBuf);
	if( !GetComma() ) return;

	dmode = GetA();
	if( dmode < 0 ) return;

	if( dmode<16 ) {			/// JSRFR f,$
		///ffff ffff ffff ffff AAAA -011 0101 0100				JSRFR f,$
		*(DWORD*)pC = 0x00000354 | (((DWORD)qv)<<16) | (dmode<<12);
		pC += 4;
	} else if( dmode==33 ) {	/// JSRFR f,=con
		///ffff ffff ffff ffff ---- --00 0101 0100 Acon		JSRFR f,=con	(BYTE address)
		*(DWORD*)pC = 0x00000054 | (((DWORD)qv)<<16);
		pC += 4;
		*(DWORD*)pC = (DWORD)paCONST;
		pC += 4;
	} else {
		ReportError("invalid addressing mode");
	}
}

///************************************
///xxxx xxxx xxxx xxxx xxxx xxDD DD00 1100				JMP [$][x]		where "[x]" is optional, and is absolute address in DWORDS (defaults to 0 if not present)
///xxxx xxxx xxxx xxxx xxxx xx00 0010 1100				JMP =x			where 'x' is absolute address in DWORDS
void ASMjmp(long opix){

	long	dmode;

	dmode = GetA();
	if( dmode < 0 ) return;

	if( dmode < 32 ) {	/// treat JMP $ and JMP [$] same as JMP [$][0]
		dmode &= 0x0F;	/// 16-31 -> 0-15
		///xxxx xxxx xxxx xxxx xxxx xxDD DD00 1100				JMP [$][x]		where "[x]" is optional, and is absolute address in DWORDS (defaults to 0 if not present)
		*(DWORD*)pC = 0x0000000C | ((paCONST>>2)<<10) | (dmode<<6);
		pC += 4;
	} else if( dmode==33 ) {	// JMP =a
		///xxxx xxxx xxxx xxxx xxxx xx00 0010 1100				JMP =x			where 'x' is absolute address in DWORDS
		*(DWORD*)pC = 0x0000002C | (((DWORD)paCONST>>2)<<10);
		pC += 4;
	} else {
		ReportError("invalid addressing mode");
	}
}

///************************************
/*
void ASMcv(long opix){

	long	amode;

	amode = GetA();
	if( amode<0 ) return;
	if( amode>7 && amode<11 ) {
		ReportError("invalid addressing mode");
		return;
	}
	*(WORD*)pC = OPtab[opix].code + (amode<<6) + (ksize<<4);	/// push out opcode
	pC += 2;

	if( amode == 10 ) {	/// =const
		*(DWORD*)pC = (DWORD)paCONST;
		pC += 4;
		return;
	}
	if( amode==15 || amode==13 || amode==12 ) {	/// needs register address pushed
		*(WORD*)pC = (paREG+1)*8;
		pC += 2;
	}
	if( amode==11 || amode==13 ) {	/// needs DWORD paCONST pushed
		*(DWORD*)pC = (DWORD)paCONST;
		pC += 4;
	}
	if( amode==14 || amode==15 ) {	/// needs WORD paCONST pushed
		if( (long long)paCONST < -32768 || (long long)paCONST > 32767 ) {
			ReportError("stack offset overflow");
			return;
		}
		*(WORD*)pC = (WORD)paCONST;
		pC += 2;
	}
}
*/

///************************************
///vvvv vvvv vvvv vvvv vvvv vvSS 1111 0100				PUSHS from (-2M) to (+2M-1)
void ASMpushs(long opix){

	long	amode;

	amode = GetA();
	if( amode < 0 ) return;
	if( amode==33 && paID==NULL && (long long)paCONST >= -4194304LL && (long long)paCONST < 4194304LL ) {
		///vvvv vvvv vvvv vvvv vvvv vvSS 1111 0100				PUSHS from (-2M) to (+2M-1)
		*(DWORD*)pC = 0x000000F4 | (ksize<<8) | (paCONST<<10);
		pC += 4;
	} else ReportError("invalid addressing mode");
}

///************************************
/// Process the source buffers
void Assemble() {

	IDPTR	pID;
	QWORD	qv;
	DWORD	dv;
	WORD	a;
	long	opix;

	for(Pass=0; Pass<2; ++Pass) {
		/// init necessary state variables for each pass
		if( Pass ) {
			TotalCodeLen = pC-Code;
			TotalZeroLen = ZeroLen;
			for(a=0; a<IDcnt; a++) {
				if( IDtab[a].flags & IDF_ZERO ) {
					IDtab[a].value += TotalCodeLen;
				}
				if( IDtab[a].flags & IDF_UNDEFINED ) {
					sprintf(ScratBuf,"undefined label: %s", IDtab[a].name);
					ReportErrorNoLine(ScratBuf);
				}
			}
		}
		CurFile = 0;
		pIB = (BYTE*)Files[CurFile].pBuf;
		LineBuf[0] = 0;
		pLB = LineBuf;
		LineNum = 0;
		CurSeg = SEG_NONE;
		pC = Code;
		ZeroLen = 0;
		ATcnt = 0;

		while( GetLine() ) {
			if( ErrCnt>20 ) {
				printf("Too many errors...\n");
				return;
			}

			if( pC-Code > CODELIMIT ) {
				ReportError("Too large to assemble (increase MAXCODEBLOCK in KASM6 source)");
				return;
			}
			NoListAddress = FALSE;	/// normal lines
/*
if( LineNum>211 && Pass ) {

}
*/

			// handle EXTERN, PUBLIC which can be anywhere
			if( GetToken(ScratBuf) ) {
		/// PUBLIC
				if( !stricmp(ScratBuf, "public") ) {
					NoListAddress = TRUE;	/// don't show code address on this line
					if( !GetToken(ScratBuf) ) {
						ReportError("missing public label");
					} else if( Pass==0 ) {
						if( NULL==(pID=FindID(ScratBuf)) ) AddID(ScratBuf, 0, IDF_UNDEFINED | IDF_PUBLIC, -1);
						else if( !(pID->flags & IDF_EXTERN) ) pID->flags |= IDF_PUBLIC;
						else {
							ReportError("declaring an EXTERN as PUBLIC");
						}
					}
					continue;
				}
		/// EXTERN
				if( !stricmp(ScratBuf, "extern") ) {
					NoListAddress = TRUE;	/// don't show code address on this line
					if( !GetToken(ScratBuf) ) {
						ReportError("missing label reference");
						continue;
					}
					if( Pass==0 ) {
						if( NULL==(pID=FindID(ScratBuf)) ) pID = AddID(ScratBuf, 0, IDF_EXTERN | IDF_UNDEFINED, -1);
						else if( pID->flags & IDF_UNDEFINED ) {
							pID->flags |= IDF_EXTERN;
						}
					}
					continue;
				}
				if( CurSeg==SEG_NONE ) {
		/// CODE
					if( !stricmp(ScratBuf, "@code") ) {
						NoListAddress = TRUE;	/// don't show code address on this line
						CurSeg = SEG_CODE;
						SegChar = 'c';
						ForceAlign(2);
						continue;
					}
		/// ZERO
					if( !stricmp(ScratBuf, "@zero") ) {
						NoListAddress = TRUE;	/// don't show code address on this line
						CurSeg = SEG_ZERO;
						SegChar = 'z';
						ForceAlign(4);
						continue;
					}
				}
				if( CurSeg!=SEG_NONE ) {
		/// SEG_END
					if( !stricmp(ScratBuf, "@seg_end") ) {
						NoListAddress = TRUE;	/// don't show code address on this line
						SegChar = ' ';
						CurSeg = SEG_NONE;
						continue;
					}
		/// ALIGN
					if( !stricmp(ScratBuf, "@align") ) {
						ParseAlign();
						if( Pass ) {
							AlignLabel = IDF_MAPLABEL;
						}
						continue;
					}
		/// LABEL
					if( ScratBuf[0]==':' ) {
						strcpy(ScratBuf, ScratBuf+1);	/// trash ':'
						if( CurSeg==SEG_ZERO ) {
							if( Pass==0 ) {
								a = IDF_ZERO;
/*								if( ScratBuf[0]==':' ) {	/// if local label
									strcpy(ScratBuf, ScratBuf+1);	/// trash second ':'
									a |= IDF_LOCAL;
								}
*/
								if( NULL==(pID=FindID(ScratBuf)) ) pID = AddID(ScratBuf, ZeroLen, a, CurFile);
								else if( !(pID->flags & IDF_UNDEFINED) ) {	/// defining already EXTERN'd or defined label
									sprintf(tmperr, "label redefinition: %s", ScratBuf);
									ReportError(tmperr);
								} else {
									pID->flags &= ~IDF_UNDEFINED;
									pID->flags |= a;
									pID->value = (QWORD)ZeroLen;
								}
							} else if( AlignLabel && ScratBuf[0]=='_' && (pID=FindID(ScratBuf)) ) {
								pID->flags |= AlignLabel;	// possibly set "add to MAP file" flag
								AlignLabel = 0;				// no further labels get added to MAP file until after next align
							}
							continue;
						}
						if( CurSeg==SEG_CODE ) {
							if( ScratBuf[0]=='@' && ScratBuf[1]==0 ) sprintf(ScratBuf, "_@%ld", ATcnt++);	// replace with made-up label
							if( Pass==0 ) {
								a = IDF_CODE;
/*								if( ScratBuf[0]==':' ) {	/// if local label
									strcpy(ScratBuf, ScratBuf+1);	/// trash second ':'
									a |= IDF_LOCAL;
								}
*/
								if( NULL==(pID=FindID(ScratBuf)) ) pID = AddID(ScratBuf, pC-Code, a, CurFile);
								else if( !(pID->flags & IDF_UNDEFINED) ) {	/// defining already EXTERN'd label
									sprintf(tmperr, "label redefinition: %s", ScratBuf);
									ReportError(tmperr);
									continue;
								} else {
									pID->flags &= ~IDF_UNDEFINED;
									pID->flags |= a;
									pID->value = (QWORD)(pC-Code);
								}
							} else if( AlignLabel && ScratBuf[0]=='_' && (pID=FindID(ScratBuf)) ) {
								pID->flags |= AlignLabel;	// possibly set "add to MAP file" flag
								AlignLabel = 0;				// no further labels get added to MAP file until after next align
							}
							continue;
						}
						sprintf(tmperr, "label outside of segment: %s", ScratBuf+1);
						ReportError(tmperr);
						continue;
					}
			/// BYTE size
					if( ScratBuf[0]=='b' && ScratBuf[1]==0 ) {	/// setting ksize or defining global BYTE value/variable
						ksize = 0;
sizecom:
						if( CurSeg==SEG_ZERO ) {	// only accept [#] for allocating uninitialized BYTE variable space
							SkipWhite();
							if( *pLB!='[') {
missclosebracket:
								sprintf(tmperr, "SEG_ZERO expected '[#]': %s", LineBuf);
								ReportError(tmperr);
								continue;
							}
							++pLB;
							GetToken(ScratBuf);
							qv = a2n(ScratBuf);
//							if( Pass==0 )
							ZeroLen += (DWORD)qv*ksizelen[ksize];
							SkipWhite();
							if( *pLB!=']' ) goto missclosebracket;
							++pLB;
							continue;
						}
						if( CurSeg==SEG_CODE ) {
							SkipWhite();
							if( ksize==0 && *pLB=='"' ) {	/// handle b ""
								++pLB;
								while( *pLB && *pLB!='"' ) {
									if( *pLB=='\\' ) {	/// handle \-quoted chars (like '\' and '"')
										++pLB;
										if( *pLB=='r' ) *pC++ = '\r';
										else if( *pLB=='n' ) *pC++ = '\n';
										else if( *pLB=='t' ) *pC++ = '\t';
										else if( *pLB=='"' ) *pC++ = '"';
										else if( *pLB=='\\') *pC++ = '\\';
										else if( isdigit(*pLB) ) {
											long	i, v;

											for(i=v=0; i<3 && *pLB>='0' && *pLB<='7'; i++, ++pLB) v = v*8+(*pLB-'0');
											--pLB;
											if( v>255 ) ReportError("invalid \\octal value");
											*pC++ = (BYTE)v;
										} else if( *pLB ) *pC++ = *pLB;
										else --pLB;
										++pLB;
									} else *pC++ = *pLB++;
								}
								if( *pLB ) ++pLB;	/// skip closing "
							} else if( isdigit(*pLB) || *pLB=='-' ) {	/// handle #,#,#...
								--pLB;	/// move back for fake comma (get's re-incremented at start of 'do')
								do {
									++pLB;	// skip comma
									GetToken(ScratBuf);
									qv = a2n(ScratBuf);
									if( (qv & ksizemask[ksize]) && (qv & ksizemask[ksize])!=ksizemask[ksize] ) {
										sprintf(tmperr, "'value too large: %s", LineBuf);
										ReportError(tmperr);
									} else {
										*(QWORD*)pC = qv;
										pC += ksizelen[ksize];
									}
									SkipWhite();
								} while( *pLB==',' );
							} else if( *pLB=='[' ) {	/// REPEATING a VALUE: [#] #
								++pLB;
								GetToken(ScratBuf);
								qv = a2n(ScratBuf);
								if( *pLB!=']' ) {
									ReportError("malformed [#]");
								} else {
									dv = (DWORD)qv;
									++pLB;
									GetToken(ScratBuf);
									if( ScratBuf[0]==0 ) {
										ReportError("missing repeat value");
									} else {
										qv = a2n(ScratBuf);
										while( dv-- ) {
											*(QWORD*)pC = qv;
											pC += ksizelen[ksize];
										}
									}
								}
							} else {	/// not list of data, so better be opcode
								GetToken(ScratBuf);
doop:;
								for(opix=0; opix<sizeof(OPtab)/sizeof(OPtab[0]); opix++) {
									if( OPtab[opix].name!=NULL ) {
										if( !stricmp(OPtab[opix].name, ScratBuf) ) {
											(*OPtab[opix].ASMfunc)(opix);
											break;
										}
									}
								}
								if( opix >= sizeof(OPtab)/sizeof(OPtab[0]) ) {
//									ReportError("Whuh we have HARE, izzuh FAILyoor ta comYOONicate!");
								}
							}
							continue;
						}
					}
			/// WORD size
					if( ScratBuf[0]=='w' && ScratBuf[1]==0 ) {	/// setting ksize or defining global WORD value/variable
						ksize = 1;
						goto sizecom;
					}
			/// DWORD size
					if( ScratBuf[0]=='d' && ScratBuf[1]==0 ) {	/// setting ksize or defining global DWORD value/variable
						ksize = 2;
						goto sizecom;
					}
			/// QWORD size
					if( ScratBuf[0]=='q' && ScratBuf[1]==0 ) {	/// setting ksize or defining global QWORD value/variable
						ksize = 3;
						goto sizecom;
					}
			/// ADDRESS insertion
					if( ScratBuf[0]=='&' && ScratBuf[1]==0 ) {	/// defining a DWORD whose value is an address of an identifier
						if( CurSeg==SEG_ZERO ) {	// nope, '&' is generating INITIALIZED values!
							sprintf(tmperr, "'&' invalid in @ZERO: %s", LineBuf);
							ReportError(tmperr);
							continue;
						}
						if( CurSeg==SEG_CODE ) {
							/// accept identifier
							SkipWhite();
							GetToken(ScratBuf);
							if( Pass==0 ) *(DWORD*)pC = 0;	/// on pass 0, just use dummy value
							else {	/// on pass 1
								if( NULL==(pID=FindID(ScratBuf)) ) {	/// if not in table, something horrible's happened on pass 0
									sprintf(tmperr, "failure to communicate: %s", ScratBuf);
									ReportError(tmperr);
								} else if( pID->flags & IDF_UNDEFINED ) {	/// not defined: error
									sprintf(tmperr, "undefined label: %s", ScratBuf);
									ReportError(tmperr);
								} else {
									*((DWORD*)pC) = (DWORD)pID->value;
								}
							}
							pC += 4;	/// advance pC over the inserted address
							continue;
						}
					}
					goto doop;	/// nothing else, it had better be an opcode, or the squid is squished.
				}
		/// END of FILE
				if( !stricmp("@end", ScratBuf) ) {
					NoListAddress = TRUE;	/// don't show code address on this line
					/// end of this file.  GetLine() at top of loop will move us to next file or terminate the while() loop
					/// force code block and Zero to even # of DWORDs at end of file, so next file starts 'clean'
					while( (pC-Code) & 3 ) *pC++ = 0;
					while( ZeroLen & 3 ) ++ZeroLen;
				}
			}
		}
	}
}

//*******************************
int main(int argc, char **argv) {

	long	i, retval, ai, ef;
	char	c;
	QWORD	qv;
	IDPTR	pID;

	retval = 0;
	quiet = FALSE;
	for(ai=1; ai<argc; ai++) {
		if( argv[ai][0]=='-' || argv[ai][0]=='/' ) {
			if( toupper(argv[ai][1])=='Q' && argv[ai][2]=='\0' ) quiet = TRUE;
			else if( toupper(argv[ai][1])=='L' && argv[ai][2]=='\0' ) ListPass0 = TRUE;
		} else {	/// assume it's a source filename
			strcpy(Files[FilesCnt].name, argv[ai]);
			/// append ".ka" if it's not specified on the command line
			if( stricmp(Files[FilesCnt].name+strlen(Files[FilesCnt].name)-3, ".ka") ) strcat(Files[FilesCnt].name, ".ka");

			if( -1==(i=_open(Files[FilesCnt].name, _O_BINARY | _O_RDONLY)) ) {
				sprintf(tmperr, "Error opening file %s", Files[FilesCnt].name);
				ReportErrorNoLine(tmperr);
				retval = 1;
				goto fin;	/// input file error
			}

			ef = _lseek(i, 0L, SEEK_END);

			if( NULL==(Files[FilesCnt].pBuf=(char *)malloc(ef+1)) ) {
				ReportErrorNoLine("Unable to allocate memory for source files.");
				_close(i);
				retval = 2;
				goto fin;	/// input file error
			}

			_lseek(i, 0L, SEEK_SET);

			/// (UTF8) START
			/// see if UTF-8 BOM is there
			_read(i, Files[FilesCnt].pBuf, 3);
			/// if not, seek back to the start, else skip it
			if( strncmp(Files[FilesCnt].pBuf, "\357\273\277", 3) ) _lseek(i, 0L, SEEK_SET);
			/// (UTF8) END

			ef = _read(i, Files[FilesCnt].pBuf, ef);
			Files[FilesCnt].pBuf[ef] = 0;
			_close(i);

			/// strip path and file extension from filename
			i = strlen(Files[FilesCnt].name);
			if( i>3 && !stricmp(".ka", &Files[FilesCnt].name[i-3]) ) {
				i -= 3;
				Files[FilesCnt].name[i] = 0;
			}
			while( i && (c=Files[FilesCnt].name[--i])!=PATHSEP && c!=DRIVESEP ) ;
			if( (c=Files[FilesCnt].name[i])==PATHSEP || c==DRIVESEP ) ++i;
			strcpy(Files[FilesCnt].name, Files[FilesCnt].name+i);

			++FilesCnt;
		}
	}
	if( FilesCnt==0 ) {
		printf("Syntax: KASM [-Q] [-L] first_file[.KA] [second_file] ... [last_file]\n");
		printf("-q or -Q causes no extraneous messages output except for errors or -L output.\n");
		printf("-l or -L causes a first pass listing to be printed to the console.\n");
		exit(3);
	}

	IDcnt = ErrCnt = 0;

	if( !quiet ) printf("KASM 6.0\nCopyright 2021 Everett Kaser.  All rights reserved.\n");

	/// create/truncate the .KL list file
	if( -1==(lfh=_open("main.kl", _O_CREAT | _O_TRUNC | _O_BINARY | _O_RDWR, _S_IREAD | _S_IWRITE)) ) {
		ReportErrorNoLine("Error creating .KL file");
		retval = 4;
		goto fin;
	}

	/// Assemble all the files
	GateErrors = TRUE;	/// don't spit errors on first pass
	Assemble();
	GateErrors = FALSE;

	if( ErrCnt ) retval = 6;
	else {
		/// set build date/build# in header
		SYSTEMTIME	curtime;

		GetLocalTime(&curtime);
		*(WORD*)(Code+KINTrevYEAR) = (WORD)curtime.wYear;
		Code[KINTrevMONTH] = (BYTE)curtime.wMonth;
		Code[KINTrevDAY] = (BYTE)curtime.wDay;

		/// read BUILDNUM and increment it
		qv = 1;
		if( -1==(i=_open("BUILDNUM", _O_BINARY | _O_RDWR)) ) {
			if( -1==(i=_open("BUILDNUM", _O_CREAT | _O_BINARY | _O_RDWR, _S_IREAD | _S_IWRITE)) ) {
				ReportErrorNoLine("Error reading/creating BUILDNUM");
			}
		}
		if( i!=-1 ) {
			ef = _read(i, ScratBuf, 32);
			ScratBuf[ef] = 0;
			qv = a2n(ScratBuf);
			++qv;
			sprintf(ScratBuf, "%lu", (DWORD)qv);
			_lseek(i, 0, SEEK_SET);
			_write(i, ScratBuf, strlen(ScratBuf));
			_close(i);
		}
		*(DWORD*)(Code+KINTrevBUILD) = (DWORD)qv;

		/// set CODE_SEG and ZERO_SEG in header
		*(QWORD*)(Code+KINTlenCODE) = (QWORD)(TotalCodeLen);
		*(QWORD*)(Code+KINTlenZERO) = (QWORD)(TotalZeroLen);

		/// create/truncate the .ke  file and write out the assembled program
		if( -1==(ofh=_open("main.ke", _O_CREAT | _O_TRUNC | _O_BINARY | _O_RDWR, _S_IREAD | _S_IWRITE)) ) {
			ReportErrorNoLine("Error creating .KE file");
			close(lfh);
			retval = 5;
			goto fin;
		}
		_write(ofh, Code, pC-Code);
		_close(ofh);
		/// dump the MAP file
		if( -1==(ofh=_open("main.map", _O_CREAT | _O_TRUNC | _O_BINARY | _O_RDWR, _S_IREAD | _S_IWRITE)) ) {
			ReportErrorNoLine("Error creating .MAP file");
			close(lfh);
			retval = 5;
			goto fin;
		}
		/// CODE and ZERO labels are intermixed. Only write the CODE labels first
		for(i=0; i<IDcnt; i++) {
			pID = &IDtab[i];
			if( (pID->flags & IDF_CODE) && (pID->flags & IDF_MAPLABEL) ) {
				sprintf(tmperr, "%6.6lX %s\r\n", (DWORD)(pID->value), pID->name);
				_write(ofh, tmperr, strlen(tmperr));
			}
		}
		/// now write the ZERO labels, who's addresses are always higher than the CODE addresses
		for(i=0; i<IDcnt; i++) {
			pID = &IDtab[i];
			if( (pID->flags & IDF_ZERO) && (pID->flags & IDF_MAPLABEL) ) {
				sprintf(tmperr, "%6.6lX %s\r\n", (DWORD)(pID->value), pID->name);
				_write(ofh, tmperr, strlen(tmperr));
			}
		}
		_close(ofh);
	}
	/// close the list files
	_close(lfh);
fin:
	if( !quiet ) printf(" code: %ld\n zero: %ld\ntotal: %ld\n", TotalCodeLen, TotalZeroLen, TotalCodeLen+TotalZeroLen);
	if( !quiet || ErrCnt ) printf("[%ld errors]\n", ErrCnt);

	return retval;
}
