//
//  kintKINT.h
//  iKINT
//
//  Created by Everett Kaser on 1/8/13.
//  Copyright (c) 2013 Everett Kaser. All rights reserved.
//

//***************************
//* KINT version numbers
//***************************
#define    INTERP_MAJORREV    6
#define    INTERP_MINORREV    0
#define    INTERP_MICROREV    19

#define MAC_PORT	1

//include "kKINT.h"

extern volatile bool gInPrintLoop;

@import Foundation;
@import AudioToolbox.AudioServices;
#import <Cocoa/Cocoa.h>
//@import UIKit;
@import CoreGraphics;

@interface kintKINT : NSObject

@end

//*****************************************
//* VERSION TO BUILD **********************
//*
#define	KINT_UNIX					0	//*
#define	KINT_OSX					1	//*

#define	KINT_MIDI				1	//*	// set to 1 to include the MIDI music playing code

//*
//* VERSION TO BUILD **********************
//*****************************************

typedef int8_t  KCHAR;
typedef int16_t KSHORT;
typedef int32_t KLONG;

#define FALSE	0
#define TRUE	1

//typedef	signed char	BOOL;
typedef	char		TCHAR;
#define	UNALIGNED

#ifndef NULL
	#define	NULL	0
#endif

#if KINT_OSX
#ifndef max
#define max(a,b) ((a) > (b) ? (a) : (b))
#endif
#ifndef min
#define min(a,b) ((a) < (b) ? (a) : (b))
#endif
#define __min min
#define __max max
#define _stricmp strcasecmp
#define kPixSize (32/8)
// #define kPixSize (24/8)
#include <Carbon/Carbon.h>
#endif

#define	Kmin(a, b)	__min(a, b)
#define	Kmax(a, b)	__max(a, b)

// WM_SIZE defines for KINT
#define	K_SIZED		0
#define	K_MINIMIZED	1
#define	K_MAXIMIZED	2
#define	K_RESTORED	3

// These are used by the modifier-changed events
enum
{
	VK_SHIFT	= 0x10,
	VK_CONTROL	= 0x11,
	VK_MENU		= 0x12,
	VK_CAPITAL	= 0x14
};
/*
// BMB rotation/flip orient values
#define	BMO_NORMAL	0	// normal orientation
#define	BMO_90		1	// rotated counter-clockwise 90
#define	BMO_180		2	// rotated counter-clockwise 180
#define	BMO_270		3	// rotated counter-clockwise 270
#define	BMO_FNORMAL	4	// flipped left-right
#define	BMO_F90		5	// flipped & rotated 90
#define	BMO_F180	6	// flipped & rotated 180
#define	BMO_F270	7	// flipped & rotated 270
*/
/*
 #define	SO_WIDE		0	// non-flipped states must be even
 #define	SO_WIDEFLIP	1	// flipped states must be odd
 #define	SO_TALL		2
 #define	SO_TALLFLIP	3
 #define	SO_GET		4
 #define	SO_FLIPPED	1	// for testing for "flipped" status
 */

void SetAppDataPath(void);
//void InitScreen(long minW, long minH);
void MakePalette(void);
void DestroyPalette(void);
void KillProgram(void);
void KINT_SetWindowPos(void);
void KINT_GetWindowPos(DWORD *r11, DWORD *r12, DWORD *r13, DWORD *r14, DWORD *r15);
void PlayMusic(char *pMem);
void StopMusic(void);
void SystemMessage(char *pMem);
KLONG GetSystemEOL(BYTE *pMem);
char *GetFileName(char *fname, char *xname);

void KGetTime(KTIME *pT);
void KTimeToString(BYTE *pMem);
DWORD KGetTicks(void);
void KSetCursor(WORD curtype);

KLONG CreateBMB(short w, short h, WORD sysBM);
void DeleteBMB(DWORD index);
void InvalidateScreen(int x1, int y1, int x2, int y2);
void FlushScreen(void);

void KCaptureMouse(BOOL cap);
void KSleep(DWORD tmilli);
DWORD KGetOSversion(BYTE *pMem);

#define MAXSNDS	30
extern	Boolean sndLoaded[MAXSNDS];
extern	SystemSoundID	sndID[MAXSNDS];

typedef struct {
	Boolean used;
	CGFloat	size;
	int		h, ah, flags;
	char	*fontName;
} FONT;
extern char	*fontNames[8];
#define MAXFONTS	16
extern FONT	kFONT[MAXFONTS];
extern int	FONTcnt;

extern int			ScrW, ScrH;

extern BYTE	*mainKE;	// struct for main .KE program

extern char	PgmPath[PATHLEN], TmpPath[PATHLEN], AppDataPath[PATHLEN], AppPath[PATHLEN];
//extern WindowRef gMacWindow;
extern bool windowReady;
extern CGContextRef gCGContext;

#define	MAXMSGS		1024	// max messages queued at a time in KINTmsgs
extern DWORD		KINTmsgs[4*MAXMSGS];
extern KLONG		KINTmsgadd, KINTmsgrem;
extern DWORD	KINTptrmove[4];

extern NSTimer *TimerID;

//*********************************************************************************
//* The following macros are used in PMACH.CPP in order to make
//* it easier for porting this code to "big-endian" CPUs.  "All" you have to do
//* is rewrite these macros, and MOST of the little-to-big-endian conversion will
//* be done.  Although, NO DOUBT, I've used these macros in some places where
//* I shouldn't have, and haven't used them in some places where I should have.
//* BEWARE!
//*********************************************************************************
#define    GETMEMB(p)    (*( BYTE*)(mainKE+(p)))
#define    GETMEMW(p)    (*( WORD*)(mainKE+(p)))
#define    GETMEMD(p)    (*(DWORD*)(mainKE+(p)))
#define    GETMEMQ(p)    (*(QWORD*)(mainKE+(p)))

#define    SETMEMB(p, v)    ((*( BYTE*)(mainKE+(p)))=(BYTE)(v))
#define    SETMEMW(p, v)    ((*( WORD*)(mainKE+(p)))=(WORD)(v))
#define    SETMEMD(p, v)    ((*(DWORD*)(mainKE+(p)))=(DWORD)(v))
#define    SETMEMQ(p, v)    ((*(QWORD*)(mainKE+(p)))=(QWORD)(v))

#define    SETSTSB(b)    (FLAGS =((((b)==0)?2:0) | ((((char)(b))<0)?4:0) | (((b)&1)?1:0)))
#define    SETSTSW(b)    (FLAGS =((((b)==0)?2:0) | ((((int16_t)(b))<0)?4:0) | (((b)&1)?1:0)))
#define    SETSTSD(b)    (FLAGS =((((b)==0)?2:0) | ((((KLONG)(b))<0)?4:0) | (((b)&1)?1:0)))
#define    SETSTSQ(b)    (FLAGS =((((b)==0)?2:0) | ((((int64_t)(b))<((int64_t)0))?4:0) | (((b)&1)?1:0)))

#define ISEQ    (FLAGS&2)
#define    ISNE    (!(FLAGS&2))
#define    ISGE    (!(FLAGS&4))
#define    ISGT    (!(FLAGS&6))
#define    ISLE    ((FLAGS&4) || (FLAGS&2))
#define    ISLT    (FLAGS&4)
#define    ISEV    (!(FLAGS&1))
#define    ISOD    (FLAGS&1)

///=================================================================
/// NOTE: SKBM can NOT be allocated dynamically on the Heap
typedef struct {
    BYTE    *pBits;        /// pointer to bits (Screen bitmap via malloc(), NOT on Heap!!!)
    KLONG    w, h, linelen;
    KLONG    clipX, clipY, clipW, clipH;
    CGContextRef    bitmapContext;
    CGImageRef         cgImage;
//    HBITMAP    hBitmap;
} SKBM;

///=================================================================
/// KBM is for all other 'memory' bitmaps, and must be created on
/// the Heap via CreateBM() and destroyed via DeleteBM().
typedef struct {
    KLONG    w, h, linelen;
    KLONG    clipX, clipY, clipW, clipH;
    DWORD    hBM;        // Heap HANDLE
} KBM;

///=================================================================
typedef struct {
    KLONG    w, h;
    KLONG    clipX, clipY, clipW, clipH;
} INFOBM;

///=================================================================
typedef struct {
    KLONG    x, y, w, h;    /// Left, Top, Right, Bottom
} KRECT;

///**************************************************************************
/// SYS commands/functions are (GROUP*256+FUNC) (that's what MAIN.KE sends us.
///**************************************************************************
/// First, we define the GROUP values:

#define    SYS_FILE    0
#define    SYS_PRINT    1
#define    SYS_TIME    2
#define    SYS_STRMEM    3
#define    SYS_WINDOW    4
#define    SYS_GRAPH    5
#define    SYS_SOUND    6
#define    SYS_SYSTEM    7
#define    SYS_CFG        8
#define    SYS_HEAP    9

/// Second, we define the FUNC values:

///==========================================
/// SYS_FILE
#define    SYS_FOPEN        0
#define    SYS_FEOF        1
#define    SYS_FREAD        2
#define    SYS_FWRITE        3
#define    SYS_FSEEK        4
#define    SYS_FREMOVE        5
#define    SYS_MKDIR        6
#define    SYS_RMDIR        7
#define    SYS_FCLOSE        8
#define    SYS_FSIZE        9
#define    SYS_FTIME        10
#define    SYS_FINDFIRST    11
#define    SYS_FINDNEXT    12
#define    SYS_FINDCLOSE    13
#define    SYS_FWRITE64    14
#define    SYS_FRENAME        15

///==========================================
#define    SYS_SETTIMER    0
#define    SYS_TIMEMILLI    1
#define    SYS_TIMESTR        2

///==========================================
/// SYS_STRMEM
#define    SYS_PRTFMT    0
#define    SYS_STRCPY    1
#define    SYS_STRCAT    2
#define    SYS_STRLEN    3
#define    SYS_STRCMP    4
#define    SYS_TOUPPER    5

#define    SYS_MEMCPY    10
#define    SYS_MEMMOVE    11
#define    SYS_MEMSET    12
#define    SYS_MEMCMP    13

#define    SYS_DBGOUT   14

///==========================================
/// SYS_GRAPH
#define    SYS_LINES            0
#define    SYS_RECT            1
#define    SYS_LOADIMG            2
#define    SYS_DRAWBM            3
#define    SYS_DELBM            4
#define    SYS_SETALPHA        5
#define    SYS_GETPIXEL        6
#define    SYS_SETPIXEL        7
#define    SYS_STRETCHBM        8
#define    SYS_SAVEIMG            9
#define    SYS_RGB2HSL            10
#define    SYS_HSL2RGB            11
#define    SYS_GETINFOBM        12
#define    SYS_CLIPBM            13
#define    SYS_LINESTYLE        14
#define    SYS_COLORIZEBM        15
#define    SYS_DRAWTEXTBM        16
#define    SYS_DRAWGRADRECTBM    17
#define    SYS_DRAWOVALBM        18
#define    SYS_CREATEBM        19

///==========================================
/// SYS_SOUND
#define    SYS_PLAYSOUND        0
#define    SYS_PLAYMUSIC        1
#define    SYS_STOPMUSIC        2
#define    SYS_ISMUSIC            3

///==========================================
/// SYS_SYSTEM
#define    SYS_SYSMSG            0
#define    SYS_GETEOL            1
#define    SYS_GETSCREENSIZE    2
#define    SYS_GETKEYMSG        3
#define    SYS_GETPTRMSG        4
#define    SYS_READCLIPBOARD    5
#define    SYS_WRITECLIPBOARD    6
#define    SYS_CAPTUREMOUSE    7
#define    SYS_GETWNDPOS        8
#define    SYS_SETWNDPOS        9
#define    SYS_GETVIEWSIZE        10
#define    SYS_SETPGMTITLE        11
#define    SYS_GETAPPDATAPATH    12
#define    SYS_GETPGMPATH        13
#define    SYS_GETOSVERSION    14
#define    SYS_GETCTRL            15
#define    SYS_SETCURSOR        16
#define    SYS_DOHTML            17
#define    SYS_GETMAXSCREEN    18
#define    SYS_GETKEYSTATUS    19

///==========================================
/// SYS_CFG
#define    SYS_INIREAD            0    /// OPENS and READS the .ini file into memory
#define    SYS_INIWRITE        1    /// WRITES the current INI buffer to the file, but keeps the buffer for further activity (i.e., just flushes it to storage)
#define    SYS_INICLOSE        2    /// free the .ini memory resources (losing any changes unless you've already done an INIWRITE)
#define    SYS_INIFINDSEC        3    /// find an already-existing section
#define    SYS_INIFINDVAR        4    /// try to find the specified variable in the current section, return TRUE if successful (with the data pointer set to that variable, ready to read/write)
#define    SYS_INIGETNUM        5    /// get a number from the current variable at the current position in the variable
#define    SYS_INIGETSTR        6    /// get a quoted string from the current variable at the current position in the variable
#define    SYS_INISETSEC        7    /// sets "current section" to the named section (creating it if it doesn't exist)
#define    SYS_INISETVAR        8    /// creates a new, or entirely replaces an old, variable in the current section with a new set of pre-formatted values
#define    SYS_INIDELSEC        9    /// delete the current section and all its variables and data
#define    SYS_INIDELVAR        10    /// delete the named variable and its value(s)
#define    SYS_ININEXTSEC        11    /// move to NEXT section, return its name
#define    SYS_INIDELALL        12    /// delete ENTIRE .ini buffer contents, but leave buffer allocated and ready to go
#define    SYS_INIENDVAR        13    /// return TRUE if no more data before End-Of-Line of current variable
#define    SYS_INIADDVARNUM    14    /// add a numeric value to the end of the variable
#define    SYS_INIADDVARSTR    15    /// add a quoted string to the end of the variable
#define    SYS_ININEXTVAR        16    /// returns the ENTIRE next variable line

///==========================================
/// SYS_HEAP
#define    SYS_HALLOC            0
#define    SYS_HFREE            1
#define    SYS_HLOCK            2
#define    SYS_HUNLOCK            3
#define    SYS_HPTR            4

///=================================================================
#define MK_LBUTT	0x0001
#define MK_RBUTT	0x0002
#define MK_SHIFT	0x0004
#define MK_CTL		0x0008
#define MK_MBUTT	0x0010
#define MK_BBUTT	0x0020
#define MK_FBUTT	0x0040
#define MK_ALT		0x8000

#define K_LBUTT		0x01
#define K_RBUTT		0x02
#define K_MBUTT		0x04

#define K_BACK		0x08
#define K_TAB		0x09
#define	K_CLEAR		0x0C
#define K_ENTER		0x0D

#define K_SHIFT		0x10
#define K_CTL		0x11
#define K_MENU		0x12
//#define	K_PAUSE	0x13
//#define	K_CAPITAL	0x14

#define K_ESC		0x1B

#define K_SPACE		0x20
#define K_PGUP		0x21
#define K_PGDN		0x22
#define K_END		0x23
#define K_HOME		0x24
#define K_LFCURS	0x25
#define K_UPCURS	0x26
#define K_RTCURS	0x27
#define K_DNCURS	0x28
//#define	K_SELECT	0x29
//#define	K_PRINT		0x2A
//#define	K_EXECUTE	0x2B
//#define	K_SNAPSHOT	0x2C
#define K_INS		0x2D
#define K_DEL		0x2E
//#define	K_HELP	0x2F

// These are just their ASCII values (uppercase for letters)
// 0-9 are 0x30 - 0x39
// A-Z are 0x41 - 0x5A
#define	K_0			0x30
#define	K_1			0x31
#define	K_2			0x32
#define	K_3			0x33
#define	K_4			0x34
#define	K_5			0x35
#define	K_6			0x36
#define	K_7			0x37
#define	K_8			0x38
#define	K_9			0x39

#define K_A			0x41
#define K_B			0x42
#define K_C			0x43
#define K_D			0x44
#define K_E			0x45
#define K_F			0x46
#define K_G			0x47
#define K_H			0x48
#define K_I			0x49
#define K_J			0x4A
#define K_K			0x4B
#define K_L			0x4C
#define K_M			0x4D
#define K_N			0x4E
#define K_O			0x4F
#define K_P			0x50
#define K_Q			0x51
#define K_R			0x52
#define K_S			0x53
#define K_T			0x54
#define K_U			0x55
#define K_V			0x56
#define K_W			0x57
#define K_X			0x58
#define	K_Y			0x59
#define	K_Z			0x5A

#define	K_LWIN			0x5B
#define	K_RWIN			0x5C
#define	K_APPS			0x5D

#define K_NUMPAD0	0x60
#define K_NUMPAD1	0x61
#define K_NUMPAD2	0x62
#define K_NUMPAD3	0x63
#define K_NUMPAD4	0x64
#define K_NUMPAD5	0x65
#define K_NUMPAD6	0x66
#define K_NUMPAD7	0x67
#define K_NUMPAD8	0x68
#define K_NUMPAD9	0x69
#define K_MULTIPLY	0x6A
#define K_NUMPADADD	0x6B
#define K_SEPARATOR	0x6C
#define K_NUMPADSUB	0x6D
#define K_DECIMAL	0x6E
#define K_NUMPADDIV	0x6F
#define K_F1		0x70
#define K_F2		0x71
#define K_F3		0x72
#define K_F4		0x73
#define K_F5		0x74
#define K_F6		0x75
#define K_F7		0x76
#define K_F8		0x77
#define K_F9		0x78
#define K_F10		0x79
#define K_F11		0x7A
#define K_F12		0x7B
#define K_F13		0x7C
#define K_F14		0x7D
#define K_F15		0x7E
#define K_F16		0x7F
#define K_F17		0x80
#define K_F18		0x81
#define K_F19		0x82
#define K_F20		0x83
#define K_F21		0x84
#define K_F22		0x85
#define K_F23		0x86
#define K_F24		0x87

#define K_NUMLOCK	0x90
#define K_SCROLL	0x91

#define	K_SEMICOLON		0xBA	// ;: key
#define K_EQPLUS		0xBB	// =+ key
#define	K_COMMA			0xBC	// ,<
#define K_UNDERSUB		0xBD	// -_ key
#define	K_PERIOD		0xBE	// .>
#define K_SLASH			0xBF	// /? key
#define	K_TILDE			0xC0	// `~
#define	K_BACKSLASH		0xDC	// \  key
#define	K_OPENBRACKET	0xDB	// [{
#define	K_BACKSLASH		0xDC	// \|
#define	K_CLOSEBRACKET	0xDD	// ]}

#define K_BACKBUTT  0x8001	// mouse BACK button
#define K_FWDBUTT   0x8002	// mouse FWD button
#define K_WHEEL		0x8003	// mouse wheel
#define	K_HWHEEL	0x8004	// mouse horizontal wheel


//**********************************************
//* .KE file header
//**********************************************
#define    KEHED_NULLPTR        0x00
#define    KEHED_R0            0x08
#define    KEHED_R1            0x10
#define    KEHED_R2            0x18
#define    KEHED_R3            0x20
#define    KEHED_R4            0x28
#define    KEHED_R5            0x30
#define    KEHED_R6            0x38
#define    KEHED_R7            0x40
#define    KEHED_R8            0x48
#define    KEHED_R9            0x50
#define    KEHED_R10            0x58
#define    KEHED_R11            0x60
#define    KEHED_R12            0x68
#define    KEHED_R13            0x70
#define    KEHED_R14            0x78
#define    KEHED_R15            0x80
#define    KEHED_PC            0x88
#define    KEHED_SB            0x90
#define    KEHED_SE            0x98
#define    KEHED_SP            0xA0
#define    KEHED_FP            0xA8
#define    KEHED_MP            0xB0
#define    KEHED_SCRATCH        0xB8
#define    KEHED_FLAGS            0xC0
#define    KEHED_EVENTVAL        0xC1
/// reserved 0xC2-0xC7
/// reserved 0xC8-0xCF
#define    KEHED_MARKER        0xD0    // 6 bytes
#define    KEHED_YEAR            0xD6    // 2 bytes
#define    KEHED_MONTH            0xD8    // 1 byte
#define    KEHED_DAY            0xD9    // 1 byte
#define    KEHED_MAJORREV        0xDA    // 1 byte
#define    KEHED_MINORREV        0xDB    // 1 byte
#define    KEHED_BUILDNUM        0xDC    // 4 bytes
#define    KEHED_CODESIZE        0xE0
#define    KEHED_ZEROSIZE        0xE8
#define    KEHED_STACKSIZE        0xF0
#define    KEHED_HEAPSIZE        0xF8
#define    KEHED_CONSTN        0x100
#define    KEHED_WNDSIZE        0x108
/// reserved 0x150-0x1FF
#define    KEHED_EVENTPROC        0x200

///======================================================================================================
#define    KMSG_INVALID_MSG        0    /// SHOULD never be sent
#define    KMSG_BEGIN_STARTUP        1    /// program is JUST starting up, window not yet created
#define    KMSG_END_STARTUP        2    /// program has finished starting up, window created, ready for normal run
#define    KMSG_QUERY_QUIT            3    /// asking if it's OK to quite the program (return 0=no, 1=yes)
#define    KMSG_SHUTDOWN            4    /// program is about to shutdown
#define    KMSG_FOCUS                5    /// KINT window got or lost input focus
#define    KMSG_SCREEN_CHANGE        6    /// screen has changed, resize/redraw EVERYTHING
#define    KMSG_WINDOW_HIDDEN        7    /// window has been minimized (arg1==1) or un-minimized (arg1==0)
#define    KMSG_WINDOW_MOVED        8    /// window has been moved
#define    KMSG_WINDOW_SIZED        9    /// window has been resized
#define    KMSG_MUSIC_DONE            10    /// music has finished playing
#define    KMSG_TIMER                11    /// a timer has elapsed
#define    KMSG_KEY_DOWN            12    /// a key has been pressed
#define    KMSG_KEY_UP                13    /// a key has been released
#define    KMSG_CHAR                14    /// a character has been typed (NOTE: a single key press may cause KEY_DOWN, CHAR, KEY_UP)
#define    KMSG_POINTER_MOVE        15    /// a pointer device (mouse, finger?) has moved (mouse button clicks come through as KEY_DOWN/KEY_UP)

//*****************************
//* function prototypes
//*****************************
int LoadKEFile(void);
BOOL KEmsg(DWORD cmd, DWORD arg1, DWORD arg2, DWORD arg3);
void ExecKE(void);
//void SysFunc(KE *pKE, WORD opcode);
void SysStartup(void);
void SysCleanup(void);
void SysExit(void);
void SysMinimize(Boolean isMin);

// graphic function prototypes
WORD FitFont(BYTE *text, WORD w, WORD h, WORD fixedpitch);

// The following are the KASM/KINT file-open flag definitions.
// These are consistent with standard C library #define values
// but if this is being translated to another language, it's
// good to know what the KASM code is going to be passing you and
// what it means....
#define	O_RDBIN		0x8000	// read only, binary
#define	O_WRBIN		0x8002	// read/write, binary
#define	O_WRBINNEW	0x8302	// read/write, binary, create or truncate
/*
// The following are the KASM/KINT file-open directories
#define	DIR_GAME		0
#define	DIR_UI			1
#define DIR_IMAGES		2
#define DIR_BACKGNDS	3
#define DIR_MUSIC		4
#define DIR_SOUNDS		5
#define	DIR_GAME_IMG	6
#define	DIR_UI_COMMON	7
#define	DIR_LOSSY		0x40
#define	DIR_NOEXT		0x80
*/
//void InitScreen(long minW, long minH);
void KillProgram(void);
void KPlaySound(char *pMem);
void SystemMessage(char *pMem);
char *GetFileName(char *fname, char *xname);

void KGetTime(KTIME *pT);
void KTimeToString(BYTE *pMem);
DWORD KGetTicks(void);

void InvalidateScreen(KLONG x1, KLONG y1, KLONG x2, KLONG y2);
void FlushScreen(void);

void KSleep(DWORD tmilli);
DWORD KGetOSversion(BYTE *pMem);
void Rectangle(DWORD hBM, CGRect rect, DWORD fillclr, DWORD edgeclr);
void Lines(DWORD hBM, CGPoint *points, size_t numpoints, CGColorRef clr);
void LinesCTX(CGContextRef ctx, CGPoint *points, size_t numpoints, CGColorRef clr);
Boolean setIntersect(CGRect *modRect, CGRect *rect2);
KLONG Kfilesize(char *fn, DWORD *timmod);
DWORD LoadBM(BYTE *fname, DWORD fnameIndex);
//void StretchBM(DWORD tarBM, KLONG tarX, KLONG tarY, KLONG tarW, KLONG tarH, DWORD srcBM, KLONG srcX, KLONG srcY, KLONG srcW, KLONG srcH);
void OvalRect(DWORD hBM, KLONG x1, KLONG y1, KLONG x2, KLONG y2, KLONG fill, KLONG edge, KLONG round);
void TextBM(DWORD hBM, KLONG x, KLONG y, char *str);
WORD FitFont(BYTE *text, WORD w, WORD h, WORD flags);
void RelFont(KLONG w);
void SetTextStyle(KLONG font, DWORD textClr, DWORD backClr);
extern KLONG	kRotated;
void TestRect(DWORD hBM, CGRect rect, DWORD fill, DWORD edge);
void SendNextMsg(void);
BOOL KeyMsg(DWORD *cmd, DWORD *arg1, DWORD *arg2, DWORD *arg3);

NSFont *FitSysFont(NSString *text, int w, int h, DWORD flags, CGSize *fontsize);

void PurgeMsgs(void);

extern bool inKE;
extern KLONG	dirtyX1, dirtyY1, dirtyX2, dirtyY2;
extern KLONG		PhysicalScreenW, PhysicalScreenH, PhysicalScreenSizeIndex;
extern SKBM    scrBM;

extern bool inKE;
extern bool windowReady;

BOOL CreateSBM(SKBM *pX, WORD w, WORD h);
DWORD CreateBM(KLONG w, KLONG h);
void DeleteSBM(SKBM *pX);
void DeleteBM(DWORD hHP);
void InvalidateScreen(KLONG x, KLONG y, KLONG w, KLONG h);
void StartDST(DWORD hBM);
void EndDST(void);
void StartSRC(DWORD hBM);
void EndSRC(void);
void StartSRCDST(DWORD hBMS, DWORD hBMD);
void EndSRCDST(void);
QWORD SetAlpha(DWORD pArgs);
DWORD GetPixelBM(DWORD hBM, KLONG x, KLONG y);
void SetPixelBM(DWORD hBM, KLONG x, KLONG y, DWORD clr);
DWORD LoadBMP(char *fname);
DWORD SaveBMP(DWORD hBM, char *fname);
void DrawBM(DWORD hDST, KLONG xd, KLONG yd, DWORD hSRC, KLONG xs, KLONG ys, KLONG ws, KLONG hs, KLONG invert, KLONG rep2x, KLONG rep2y);
void StretchBM(DWORD pArgs);
void EnlargeBM(DWORD pArgs);
void DrawLineBM(DWORD hBM, KLONG x1, KLONG y1, KLONG x2, KLONG y2, DWORD clr);
void DrawLines(DWORD hBM, KLONG *pPoints, KLONG num, DWORD clr);
void DrawRect(DWORD hBM, KLONG x1, KLONG y1, KLONG wi, KLONG hi, DWORD fill, DWORD edge);
void RectGradientBM(DWORD pArgs);
void DrawOvalBM(DWORD pArgs);
DWORD LoadPNG(char *fname);
DWORD SavePNG(DWORD hBM, char *fname);
DWORD LoadImg(char *fname);
DWORD SaveImg(DWORD hBM, char *fname, KLONG format);
DWORD RGB2HSL(DWORD argb);
DWORD HSL2RGB(DWORD ahsl);
void GetInfoBM(DWORD hBM, INFOBM *pIBM);
void ClipBM(DWORD hBM, KLONG x, KLONG y, KLONG w, KLONG h, KRECT *pRect);
QWORD SetLineStyle(QWORD ls);
void ColorizeBM(DWORD pArgs);
void InitSysFonts(void);
void FreeSysFonts(void);
DWORD DrawSysFontText(DWORD pArgs);
void SetAppDataPath(void);
void StartTimer(DWORD timval);
void StopTimer(void);
